#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=Resources\Icon.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Res_Comment=The program designed to post Highlighted AutoIt-code to forums and blogs
#AutoIt3Wrapper_Res_Fileversion=3.6.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Copyright  2006-2015 G.Sandler (CreatoR), www.autoit-script.ru. All rights reserved.
#AutoIt3Wrapper_Res_Language=1049
#AutoIt3Wrapper_Res_Field=CompanyName|CreatoR's Lab - http://creator-lab.ucoz.ru
#AutoIt3Wrapper_AU3Check_Stop_OnWarning=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#Region Header

#CS =====================================================================================================

=========
Au3ToPost
=========

Description:
			* The program designed to post Highlighted AutoIt-code to forums and blogs.
			*       AutoIt-    .

Author(s):	G.Sandler a.k.a CreatoR (http://autoit-script.ru, http://creator-lab.ucoz.ru)

Credits:
			A.Melnichuk a.k.a amel27 for...:
				* Help with Regular Expression in Au3SyntaxHighlight.au3.
			
			Yashied for....................:
				* HotKey.au3
				* HotKeyInput.au3

#CE ----------------------------------------------------------------------------

;  
#include <GUIConstantsEx.au3>
#include <Constants.au3>
#include <WindowsConstants.au3>
#include <StaticConstants.au3>
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#Include <Array.au3>
#Include <Misc.au3>
#include <File.au3>
#Include <String.au3>

#include "Includes\Translation.au3"
#Include "Includes\Encoding.au3"
#Include "Includes\Au3SyntaxHighlight.au3"
#Include "Includes\GUICtrlCreateTFLabel.au3"
#Include "Includes\AboutBox.au3"
#Include "Includes\AppCheckUpdates.au3"
#Include "Includes\HotKey.au3"
#Include "Includes\HotKeyInput.au3"

#EndRegion Header

#Region Options / Variables

Opt("MustDeclareVars", 1)
Opt("TrayMenuMode", 1 + 2)
Opt("TrayOnEventMode", 1)

; 
Global $nMain_Menu, $nSettings_Item, $nLanguage_Item, $nGoToSilentMode_Item, $nIntegrateToSciTe_Item, $nExit_Item, $nHelp_Menu, $nCheckUpdates_Item, $nAbout_Item, $nStartParse_TrayItem, $nEndSilentMode_TrayItem
Global $nExit_TrayItem, $nOutFile_Input, $nSelectOutFile_Button, $nNoOutFileSave_CB, $nInFile_Input, $nSelectInFile_Button, $nEditScriptContent_CB, $nScriptContent_Edit
Global $nOk_Button, $nCancel_Button, $nMsg

Global $sCustomScriptContent 		= ""
Global $iCustomScriptContentCheck 	= 0

If StringInStr($CmdLineRaw, "/Selection:") Then
	$sCustomScriptContent = StringRegExpReplace($CmdLineRaw, "(?si).*?/Selection:(.*?)$", "\1")
	
	If _Encoding_IsUTF8Format($sCustomScriptContent) Then
		$sCustomScriptContent = _Encoding_UTF8ToANSI($sCustomScriptContent)
	EndIf
EndIf

;   AutoIt   SciTE
Global $sScript_Path 			= StringTrimRight(@ScriptFullPath, 4)
Global $sConfig_File 			= $sScript_Path & ".ini"

Global $sAutoItPath 			= _Iif(@Compiled, RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\AutoIt v3\AutoIt", "InstallDir"), StringLeft(@AutoItExe, StringInStr(@AutoItExe, "\", 0, -1)-1))
Global $sSciTEDir 				= _GetSciTEDir($sAutoItPath)
Global $sSciTEPath 				= FileGetShortName($sSciTEDir) & "\SciTE.exe"

;    
Global $sInFile 				= $sScript_Path & '.au3'
Global $sOutFile 				= $sScript_Path & '.txt'

;  
Global $sApp_Language			= IniRead($sConfig_File, "Prefs", "Language", "English")
Global $iAddURLs 				= IniRead($sConfig_File, "Prefs", "Add URLs To Funcs", 0)
Global $sWrapTagsTemplate 		= IniRead($sConfig_File, "Prefs", "Wrap Tags Template", "[code]%s[/code]")
Global $iSetOnTop				= IniRead($sConfig_File, "Prefs", "Set On Top", 1)
Global $iGoToSilent_Mode 		= IniRead($sConfig_File, "Prefs", "Minimize to Silent Mode", 0)
Global $sLastInFile 			= IniRead($sConfig_File, "Prefs", "Last used inFile", "")
Global $sLastOutFile 			= IniRead($sConfig_File, "Prefs", "Last used outFile", "")
Global $iNotWriteOutFile 		= IniRead($sConfig_File, "Prefs", "Not write out file", 1)
Global $iTypeCustomCode 		= IniRead($sConfig_File, "Prefs", "Type Custom Code", 0)
Global $iHighlight_Mode			= IniRead($sConfig_File, "Prefs", "Highlight Mode", 3) ; -1 = Html, 3 = BBCode
Global $iSilent_Mode			= IniRead($sConfig_File, "Prefs", "Silent Mode", 0)
Global $sSilentMode_HotKey		= IniRead($sConfig_File, "Prefs", "Silent Mode HotKey", 0x0651) ;Ctrl + Alt + Q
Global $sAbortHighlight_HotKey	= IniRead($sConfig_File, "Prefs", "Abort Highlight HotKey", 0x0341) ;Ctrl + Shift + A
Global $iAutoUpdateOnStart		= IniRead($sConfig_File, "Prefs", "AutoUpdate On Start", 1)
Global $iAutoUpdateInterval		= IniRead($sConfig_File, "Prefs", "AutoUpdate Interval", 72) ;72 hours
Global $iAutoUpdateCheckStamp	= IniRead($sConfig_File, "Prefs", "AutoUpdate Check Stamp", -1)

;  
Global $aTXT 					= _AppTranslation_Register($LANGS_DIR & "\" & $sApp_Language & ".lng")

;   
Global $sScript_Read 			= FileRead(@ScriptFullPath)

Global $sApp_ShortTitle 		= "Au3ToPost"
Global $sApp_Title 				= $sApp_ShortTitle & " - " & $aTXT[$iMSG_Au3]
Global $sApp_Version 			= _Iif(@Compiled, StringLeft(FileGetVersion(@ScriptFullPath), 3), StringRegExpReplace($sScript_Read, "(?is).*?#AutoIt3Wrapper_Res_FileVersion=(\d\.\d).*", "\1"))
Global $sApp_Descript 			= _Iif(@Compiled, StringLeft(FileGetVersion(@ScriptFullPath, "Comment"), 3), StringRegExpReplace($sScript_Read, "(?is).*?#AutoIt3Wrapper_Res_Comment=([^\r\n]*).*", "\1"))
Global $sApp_Copyright 			= _Iif(@Compiled, FileGetVersion(@ScriptFullPath, "LegalCopyright"), StringRegExpReplace($sScript_Read, "(?is).*?#AutoIt3Wrapper_Res_LegalCopyright=([^\r\n]*).*", "\1"))

Global $sApp_FullTitle 			= $sApp_Title & " v" & $sApp_Version
Global $sApp_TestedOn 			= "Win XP SP3 / Win7"

;    
Global $sAppUpdate_TriggerURL	= "http://creator-lab.ucoz.ru/load/0-0-1-18-20"
Global $sAppUpdate_ServerPage 	= "http://creator-lab.ucoz.ru/Update_Files/Au3ToPostUpdate.dat"
Global $sAppUpdate_AppName 		= $sApp_ShortTitle
Global $sAppUpdate_AppVersion 	= $sApp_Version

;     
Global $aAppUpdate_Msgs[12] 	= _
	[11, _
		$aTXT[$iMSG__0], _
		$aTXT[$iMSG__1], _
		$aTXT[$iMSG__2], _
		$aTXT[$iMSG__3], _
		$aTXT[$iMSG_I], _
		$aTXT[$iMSG_SnnNnsnn], _
		$aTXT[$iMSG_I_1], _
		$aTXT[$iMSG__4], _
		$aTXT[$iMSG__5], _
		$aTXT[$iMSG_S], _
		$aTXT[$iMSG_S_1] _
	]

; GUI
Global $iMainGUI_Width 			= 600
Global $iMainGUI_Height 		= 500
Global $iResultsGUI_Width		= @DesktopWidth - 250
Global $iResultsGUI_Height		= @DesktopHeight - 250

;    
$iAu3SH_AddURLs = Number($iAddURLs)

If $sLastInFile <> "" Then $sInFile = $sLastInFile
If $sLastOutFile <> "" Then $sOutFile = $sLastOutFile

If $CmdLine[0] > 0 Then
	If StringInStr($CmdLineRaw, "/FilePath:") Then
		$sInFile = _GetCmdLine($CmdLineRaw, '/FilePath:')
	Else
		$sInFile = $CmdLine[1]
	EndIf
EndIf

;  
Global $sAu3Content = FileRead($sInFile)

;  .     
Global $iSilentMode_HotKey_Called = 0

;    
If $iSilent_Mode = 1 Then
	_SilentCheckUpdates_Proc(0)
	_SilentMode_Proc(1)
EndIf

#EndRegion Options / Variables

#Region GUI Creation

; GUI
Global $hMain_GUI = GUICreate($sApp_FullTitle, $iMainGUI_Width, $iMainGUI_Height, -1, -1, _
	BitOR($WS_MAXIMIZEBOX, $WS_MINIMIZEBOX, $WS_SIZEBOX, $WS_BORDER, $WS_CLIPCHILDREN), $WS_EX_CLIENTEDGE)

GUIRegisterMsg($WM_GETMINMAXINFO, "WM_GETMINMAXINFO")

;   GUI
If Not @Compiled Then
	GUISetIcon(@ScriptDir & "\Resources\Icon.ico")
EndIf

#Region Menu

; 
$nMain_Menu = GUICtrlCreateMenu($aTXT[$iMSG__6])
$nSettings_Item = GUICtrlCreateMenuItem($aTXT[$iMSG__7] & @TAB & "(F2)", $nMain_Menu)
$nLanguage_Item = GUICtrlCreateMenuItem("Language", $nMain_Menu)
GUICtrlCreateMenuItem("", $nMain_Menu)
$nGoToSilentMode_Item = GUICtrlCreateMenuItem($aTXT[$iMSG__8] & @TAB & "(CTRL + Q)", $nMain_Menu)
$nIntegrateToSciTe_Item = GUICtrlCreateMenuItem($aTXT[$iMSG_SciTE] & @TAB & "(CTRL + I)", $nMain_Menu)
GUICtrlCreateMenuItem("", $nMain_Menu)
$nExit_Item = GUICtrlCreateMenuItem($aTXT[$iMSG__9] & @TAB & "(ESC)", $nMain_Menu)

; 
$nHelp_Menu = GUICtrlCreateMenu($aTXT[$iMSG__10])
$nCheckUpdates_Item = GUICtrlCreateMenuItem($aTXT[$iMSG__11] & @TAB & "(CTRL + U)", $nHelp_Menu)
$nAbout_Item = GUICtrlCreateMenuItem($aTXT[$iMSG__12] & @TAB & "(F1)", $nHelp_Menu)

#EndRegion Menu

#Region Tray Controls

TraySetClick(16)
TraySetOnEvent($TRAY_EVENT_PRIMARYUP, "_Main_Tray_Events")

$nStartParse_TrayItem = TrayCreateItem($aTXT[$iMSG__13] & @TAB & "(" & _KeyToStr($sSilentMode_HotKey, "+") & ")")
TrayItemSetState(-1, $TRAY_DEFAULT)
TrayItemSetOnEvent(-1, "_Main_Tray_Events")

$nEndSilentMode_TrayItem = TrayCreateItem($aTXT[$iMSG__14])
TrayItemSetOnEvent(-1, "_Main_Tray_Events")

TrayCreateItem("")

$nExit_TrayItem = TrayCreateItem($aTXT[$iMSG__15])
TrayItemSetOnEvent(-1, "_Main_Tray_Events")

#EndRegion Tray Controls

#Region Main Controls

GUICtrlCreateLabel($aTXT[$iMSG__16], 190, 20, -1, 17)
$nOutFile_Input = GUICtrlCreateInput($sOutFile, 185, 40, 370, 20, BitOR($ES_AUTOHSCROLL, $ES_READONLY), $SS_BLACKFRAME)
$nSelectOutFile_Button = GUICtrlCreateButton("...", $iMainGUI_Width-40, 40, 20, 20)

$nNoOutFileSave_CB = GUICtrlCreateCheckbox($aTXT[$iMSG__17], 20, 40)

GUICtrlCreateLabel($aTXT[$iMSG__18], 190, 80, 300, 17)
$nInFile_Input = GUICtrlCreateInput($sInFile, 185, 100, 370, 20, BitOR($ES_AUTOHSCROLL, $ES_READONLY), $SS_BLACKFRAME)
$nSelectInFile_Button = GUICtrlCreateButton("...", $iMainGUI_Width-40, 100, 20, 20)

$nEditScriptContent_CB = GUICtrlCreateCheckbox($aTXT[$iMSG__19], 20, 100)

$nScriptContent_Edit = GUICtrlCreateEdit("", 20, 130, $iMainGUI_Width-40, $iMainGUI_Height-220, _
	BitOR($GUI_SS_DEFAULT_EDIT, $ES_READONLY), BitOR($WS_EX_DLGMODALFRAME, $WS_EX_CLIENTEDGE))

GUICtrlSendMsg(-1, $EM_LIMITTEXT, -1, 0)
GUICtrlSetData($nScriptContent_Edit, $sAu3Content)
GUICtrlSetState(-1, $GUI_FOCUS)

$nOk_Button = GUICtrlCreateButton($aTXT[$iMSG__20], ($iMainGUI_Width/2)-100, $iMainGUI_Height-75, 70)
GUICtrlSetState(-1, $GUI_DEFBUTTON)
$nCancel_Button = GUICtrlCreateButton($aTXT[$iMSG__21], ($iMainGUI_Width/2)+30, $iMainGUI_Height-75, 70)

#EndRegion Main Controls

#EndRegion GUI Creation

#Region Initializing

;   \ 
If $iNotWriteOutFile = 1 Then
	GUICtrlSetState($nNoOutFileSave_CB, $GUI_CHECKED)
	_SwitchOutFileField_Proc()
EndIf

If ($iTypeCustomCode = 1 And $CmdLine[0] = 0) Or $sCustomScriptContent <> "" Then
	If $sCustomScriptContent <> "" Then $iCustomScriptContentCheck = 1
	
	GUICtrlSetState($nEditScriptContent_CB, $GUI_CHECKED)
	_SwitchEditField_Proc()
EndIf

If $iSetOnTop = 1 Then
	WinSetOnTop($hMain_GUI, "", 1)
EndIf

; GUI
GUISetState(@SW_SHOW, $hMain_GUI)

;     (Inputs)
GUIRegisterMsg($WM_COMMAND, "WM_COMMAND")

; 5    (   )
AdlibRegister("_CheckInputs_Proc", 5000)

_FixAccelHotKeyLayout()

Global $nTab_DummyCtrl = GUICtrlCreateDummy()
Global $nSelAll_DummyCtrl = GUICtrlCreateDummy()

Global $aAccelKeys[7][2] = _ 
	[ _
		["{TAB}", $nTab_DummyCtrl], _
		["^a", $nSelAll_DummyCtrl], _
		["{F1}", $nAbout_Item], _
		["{F2}", $nSettings_Item], _
		["^q", $nGoToSilentMode_Item], _
		["^i", $nIntegrateToSciTe_Item], _
		["^u", $nCheckUpdates_Item] _
	]

GUISetAccelerators($aAccelKeys, $hMain_GUI)

;    
_SilentCheckUpdates_Proc($hMain_GUI)

#EndRegion Initializing

#Region Main Loop

; 
While 1
	$nMsg = GUIGetMsg()
	
	If $iSilentMode_HotKey_Called = 1 Then
		$iSilentMode_HotKey_Called = 0
		
		_HotKeyRelease()
		_SilentMode_Proc(0)
		_HotKeyAssign($sSilentMode_HotKey, "_HK_SilentMode_Proc")
	EndIf
	
	;   /
	Switch $nMsg
		Case $nCancel_Button, $nExit_Item, $GUI_EVENT_CLOSE
			;
			GUISetState(@SW_HIDE, $hMain_GUI)
			_ExitScript_Proc()
		Case $nGoToSilentMode_Item, $GUI_EVENT_MINIMIZE
			If $nMsg = $GUI_EVENT_MINIMIZE And $iGoToSilent_Mode = 0 Then ContinueLoop
			
			GUISetState(@SW_HIDE, $hMain_GUI)
			TraySetState(1)
			
			_HotKeyAssign($sSilentMode_HotKey, "_HK_SilentMode_Proc")
		Case $nTab_DummyCtrl
			If _IsFocused($hMain_GUI, $nScriptContent_Edit) Then
				;    Edit  (Chr(9) -> @TAB)
				ControlSend($hMain_GUI, "", $nScriptContent_Edit, "^{TAB}")
			EndIf
		Case $nSelAll_DummyCtrl
			If _IsFocused($hMain_GUI, $nScriptContent_Edit) Then
				;    Edit 
				GUICtrlSendMsg($nScriptContent_Edit, $EM_SETSEL, 0, StringLen(GUICtrlRead($nScriptContent_Edit)))
			EndIf
		Case $nIntegrateToSciTe_Item
			_IntegrateToSciTE_Proc()
		Case $nSettings_Item
			GUISetState(@SW_DISABLE, $hMain_GUI)
			Local $hHLMode_GUI = GUICreate($sApp_ShortTitle & " - " & $aTXT[$iMSG__22], 400, 500, -1, -1, -1, $WS_EX_TOOLWINDOW, $hMain_GUI)
			
			GUICtrlCreateGroup($aTXT[$iMSG__23], 20, 20, 360, 120)
			
			Local $nAddURLs_CB = GUICtrlCreateCheckbox($aTXT[$iMSG__24], 30, 40)
			Local $nGoToSilentMode_CB = GUICtrlCreateCheckbox($aTXT[$iMSG__25], 30, 60)
			Local $nSetOnTop_CB = GUICtrlCreateCheckbox($aTXT[$iMSG__26], 30, 80)
			Local $nSilentMode_CB = GUICtrlCreateCheckbox($aTXT[$iMSG__27], 30, 100)
			
			If $iAddURLs = 1 Then GUICtrlSetState($nAddURLs_CB, $GUI_CHECKED)
			If $iGoToSilent_Mode = 1 Then GUICtrlSetState($nGoToSilentMode_CB, $GUI_CHECKED)
			If $iSetOnTop = 1 Then GUICtrlSetState($nSetOnTop_CB, $GUI_CHECKED)
			If $iSilent_Mode = 1 Then GUICtrlSetState($nSilentMode_CB, $GUI_CHECKED)
			
			GUICtrlCreateGroup($aTXT[$iMSG__28], 20, 150, 360, 120)
			
			Local $nHtmlMode_Radio = GUICtrlCreateRadio($aTXT[$iMSG_Html], 30, 170)
			Local $nBBCodeMode_Radio = GUICtrlCreateRadio($aTXT[$iMSG_BBCode], 30, 200)
			
			GUICtrlCreateLabel($aTXT[$iMSG__29], 30, 225, -1, 15)
			Local $nBBCodeTagsTemplate_Input = GUICtrlCreateInput($sWrapTagsTemplate, 30, 240, 330, 20)
			
			If $iHighlight_Mode = -1 Then
				GUICtrlSetState($nHtmlMode_Radio, $GUI_CHECKED)
				GUICtrlSetState($nBBCodeTagsTemplate_Input, $GUI_DISABLE)
			Else
				GUICtrlSetState($nBBCodeMode_Radio, $GUI_CHECKED)
			EndIf
			
			GUICtrlCreateGroup($aTXT[$iMSG__30], 20, 280, 360, 70)
			
			GUICtrlCreateLabel($aTXT[$iMSG__31], 30, 300, -1, 15)
			Local $nSilentModeHotkey_Input = _GUICtrlCreateHotKeyInput($sSilentMode_HotKey, 240, 297, 120, 20, -1, -1, "+")
			
			GUICtrlCreateLabel($aTXT[$iMSG__32], 30, 325, -1, 15)
			Local $nAbortHighlightHotkey_Input = _GUICtrlCreateHotKeyInput($sAbortHighlight_HotKey, 240, 322, 120, 20, -1, -1, "+")
			
			_KeyLock(0x062E) ; Lock CTRL-ALT-DEL for Hotkey Input control, but not for Windows
			
			GUICtrlCreateGroup($aTXT[$iMSG__33], 20, 360, 360, 100)
			
			Local $nAutoUpdateOnStart_CB = GUICtrlCreateCheckbox($aTXT[$iMSG__34], 30, 380)
			
			GUICtrlCreateLabel($aTXT[$iMSG__35], 30, 412, -1, 15)
			GUICtrlCreateLabel($aTXT[$iMSG__36], 320, 412, -1, 15)
			
			Local $nAutoUpdateInterval_Input = GUICtrlCreateInput($iAutoUpdateInterval, 220, 410, 80, 20, BitOR($ES_LEFT, $ES_AUTOHSCROLL, $ES_READONLY))
			GUICtrlCreateUpdown($nAutoUpdateInterval_Input)
			GUICtrlSetLimit(-1, 24 * 30, 1) ;Maximum 30 days, Minimum 1 hour
			
			If $iAutoUpdateOnStart = 1 Then
				GUICtrlSetState($nAutoUpdateOnStart_CB, $GUI_CHECKED)
			EndIf
			
			Local $nApply_Button = GUICtrlCreateButton($aTXT[$iMSG__37], 20, 470, 70, 20)
			Local $nCancelSettings_Button = GUICtrlCreateButton($aTXT[$iMSG__38], 100, 470, 70, 20)
			
			GUISetState(@SW_SHOW, $hHLMode_GUI)
			
			While 1
				Switch GUIGetMsg()
					Case $GUI_EVENT_CLOSE, $nCancelSettings_Button
						ExitLoop
					Case $nHtmlMode_Radio
						GUICtrlSetState($nBBCodeTagsTemplate_Input, $GUI_DISABLE)
					Case $nBBCodeMode_Radio
						GUICtrlSetState($nBBCodeTagsTemplate_Input, $GUI_ENABLE)
					Case $nApply_Button
						; 
						$iAddURLs = Number(GUICtrlRead($nAddURLs_CB) = $GUI_CHECKED)
						$iGoToSilent_Mode = Number(GUICtrlRead($nGoToSilentMode_CB) = $GUI_CHECKED)
						$iSetOnTop = Number(GUICtrlRead($nSetOnTop_CB) = $GUI_CHECKED)
						$iSilent_Mode = Number(GUICtrlRead($nSilentMode_CB) = $GUI_CHECKED)
						
						If GUICtrlRead($nHtmlMode_Radio) = $GUI_CHECKED Then
							$iHighlight_Mode = -1
						Else
							$iHighlight_Mode = 3
						EndIf
						
						$sWrapTagsTemplate = GUICtrlRead($nBBCodeTagsTemplate_Input)
						If Not StringInStr($sWrapTagsTemplate, "%s") Then $sWrapTagsTemplate = "%s"
						
						$sSilentMode_HotKey = _GUICtrlReadHotKeyInput($nSilentModeHotkey_Input)
						TrayItemSetText($nStartParse_TrayItem, $aTXT[$iMSG__39] & @TAB & "(" & _KeyToStr($sSilentMode_HotKey, "+") & ")")
						
						$sAbortHighlight_HotKey = _GUICtrlReadHotKeyInput($nAbortHighlightHotkey_Input)
						
						_GUICtrlReleaseHotKeyInput()
						
						$iAutoUpdateOnStart = Number(GUICtrlRead($nAutoUpdateOnStart_CB) = $GUI_CHECKED)
						$iAutoUpdateInterval = GUICtrlRead($nAutoUpdateInterval_Input)
						
						; 
						$iAu3SH_AddURLs = $iAddURLs
						WinSetOnTop($hMain_GUI, "", $iSetOnTop)
						
						IniWrite($sConfig_File, "Prefs", "Set On Top", $iSetOnTop)
						IniWrite($sConfig_File, "Prefs", "Minimize to Silent Mode", $iGoToSilent_Mode)
						IniWrite($sConfig_File, "Prefs", "Add URLs To Funcs", $iAddURLs)
						IniWrite($sConfig_File, "Prefs", "Wrap Tags Template", $sWrapTagsTemplate)
						IniWrite($sConfig_File, "Prefs", "Highlight Mode", $iHighlight_Mode)
						
						IniWrite($sConfig_File, "Prefs", "Silent Mode", $iSilent_Mode)
						IniWrite($sConfig_File, "Prefs", "Silent Mode HotKey", $sSilentMode_HotKey)
						
						IniWrite($sConfig_File, "Prefs", "Abort Highlight HotKey", $sAbortHighlight_HotKey)
						
						IniWrite($sConfig_File, "Prefs", "AutoUpdate On Start", $iAutoUpdateOnStart)
						IniWrite($sConfig_File, "Prefs", "AutoUpdate Interval", $iAutoUpdateInterval)
						
						If $iAutoUpdateOnStart = 0 Then
							IniWrite($sConfig_File, "Prefs", "AutoUpdate Check Stamp", -1)
						EndIf
						
						ExitLoop
				EndSwitch
			WEnd
			
			GUISetState(@SW_ENABLE, $hMain_GUI)
			GUIDelete($hHLMode_GUI)
		Case $nLanguage_Item
			Local $sLanguage = _AppTranslation_SelectLangGUI($sApp_ShortTitle, $hMain_GUI, $sApp_Language)
			
			If $sLanguage <> $sApp_Language Then
				$sApp_Language = $sLanguage
				IniWrite($sConfig_File, "Prefs", "Language", $sApp_Language)
				
				MsgBox(48, $aTXT[$iMSG__0], $aTXT[$iMSG_RetsartProgram], 0, $hMain_GUI)
			EndIf
		Case $nCheckUpdates_Item
			;ShellExecute("http://creator-lab.ucoz.ru/load/3-1-0-18")
			_AppCheckUpdates($hMain_GUI, -1, 1, $sApp_Language)
		Case $nAbout_Item
			Local $sTitle, $sScrollText, $nLinkColor, $nBkColor, $aHyperLinks[3]
			
			$ABOUTBOX_ScrollMovieEffect = 1
			
			$sTitle = $sApp_ShortTitle & " - " & "About"
			
			$sScrollText = "~=~=~=~=~=~=~=~=~=~\n" & $sApp_Title & "\nv" & $sApp_Version & "\n~=~=~=~=~=~=~=~=~=~\n\n\n\n\n\n" & _
				$sApp_Descript & "\n\n~~~~~~~~~~~~~~~~~~\n" & _
				$aTXT[$iMSG_TestedOn] & " \n" & $sApp_TestedOn & "\n~~~~~~~~~~~~~~~~~~\n\n\n\n" & _
				"-----------\n" & $aTXT[$iMSG_Credits] & "\n-----------\n\nA.Melnichuk a.k.a amel27\n(RegExp in Au3SyntaxHighlight.au3)\n\n" & _
				"Yashied\n(HotKey.au3, HotKeyInput.au3)\n\n" & _
				$aTXT[$iMSG_AutoItTeamnAuto_ynAndManyOthers]
			
			$nLinkColor = 0x0000FF
			$nBkColor = 0xFFFFFF
			
			$aHyperLinks[0] = 2
			$aHyperLinks[1] = "CreatoR's Lab|http://creator-lab.ucoz.ru"
			$aHyperLinks[2] = "Autoit Russian Community|http://autoit-script.ru"
			
			_AboutBox($sTitle, $sApp_Title, $aTXT[$iMSG_Version] & @CRLF & $sApp_Version, $sScrollText, $sApp_Copyright, $aHyperLinks, $hMain_GUI, @AutoItExe, $nLinkColor, $nBkColor, 500, 300)
		Case $nSelectInFile_Button
			;    
			Local $sInFilePath = FileOpenDialog($aTXT[$iMSG__40], "", _
				"AutoIt v3 Script (*.au3)", 3, StringRegExpReplace(GUICtrlRead($nInFile_Input), "^.*\\", ""), $hMain_GUI)
			If @error Then ContinueLoop
			
			GUICtrlSetData($nInFile_Input, $sInFilePath)
			GUICtrlSetData($nScriptContent_Edit, FileRead(GUICtrlRead($nInFile_Input)))
		Case $nSelectOutFile_Button
			;      
			Local $sOutFilePath = FileSaveDialog($aTXT[$iMSG__41], "", $aTXT[$iMSG_TxtFiles] & " (*.txt)|" & $aTXT[$iMSG_AllFiles] & " (*.*)", 18, GUICtrlRead($nOutFile_Input), $hMain_GUI)
			
			If Not @error Then
				GUICtrlSetData($nOutFile_Input, $sOutFilePath)
			EndIf
		Case $nEditScriptContent_CB
			_SwitchEditField_Proc()
		Case $nNoOutFileSave_CB
			_SwitchOutFileField_Proc()
		Case $nOk_Button
			;  
			
			Local $sInputFile, $sInputFileName, $sOutputFile, $sOutputFileName, $sScriptEditContent, $iEditScriptContent, $iNoOutFileSave
			Local $sMsgStart, $sMsgFinish, $sSeccesOrFailMsg, $sResults, $iError
			Local $nSplash_Style, $nSplash_ExStyle, $hSplashMsg_GUI
			Local $iHighlightProc_TimerInit, $iHighlightProc_TimerDiff
			
			$sInputFile = GUICtrlRead($nInFile_Input)
			$sInputFileName = StringRegExpReplace($sInputFile, "^.*\\", "")
			
			$sOutputFile = GUICtrlRead($nOutFile_Input)
			$sOutputFileName = StringRegExpReplace($sOutputFile, "^.*\\", "")
			
			$sScriptEditContent = StringStripWS(GUICtrlRead($nScriptContent_Edit), 3)
			$iEditScriptContent = Number(GUICtrlRead($nEditScriptContent_CB) = 1)
			$iNoOutFileSave = Number(GUICtrlRead($nNoOutFileSave_CB) = 1)
			
			If Not FileExists($sInputFile) And Not $iEditScriptContent Then
				MsgBox(48, $aTXT[$iMSG__42], StringFormat($aTXT[$iMSG_S_2], $sInputFileName), 0, $hMain_GUI)
				ContinueLoop
			EndIf
			
			If $sScriptEditContent = "" Then
				MsgBox(48, $aTXT[$iMSG__43], $aTXT[$iMSG__44], 0, $hMain_GUI)
				ContinueLoop
			EndIf
			
			If StringRegExp($sScriptEditContent, '(?is)\[co(de|lor)(=.*)?\].*?\[/co\1\]') Then
				If MsgBox(52, $aTXT[$iMSG__45], $aTXT[$iMSG__46], 0, $hMain_GUI) <> 6 Then
					ContinueLoop
				EndIf
			EndIf
			
			If $iEditScriptContent Then
				$sAu3Content = $sScriptEditContent
			Else
				$sAu3Content = FileRead($sInputFile)
			EndIf
			
			If $iEditScriptContent Then
				$sMsgStart = $aTXT[$iMSG__47]
			Else
				$sMsgStart = StringFormat($aTXT[$iMSG_S_3], _StringGetShortString($sInputFileName, 20))
			EndIf
			
			$sSeccesOrFailMsg = $aTXT[$iMSG__48]
			
			$nSplash_Style = BitOR($WS_POPUP, $DS_SETFOREGROUND)
			$nSplash_ExStyle = BitOR($WS_EX_CLIENTEDGE, $WS_EX_DLGMODALFRAME, $WS_EX_CONTROLPARENT)
			
			If $iSetOnTop = 1 Then
				$nSplash_ExStyle = BitOR($nSplash_ExStyle, $WS_EX_TOPMOST)
			EndIf
			
			$hSplashMsg_GUI = _SplashTextOnEx($aTXT[$iMSG__49], StringFormat($aTXT[$iMSG_Nn]) & $sMsgStart, _
				300, 150, -1, -1, "Tahoma", 10, 800, 0, 0x0000FF, $nSplash_Style, $nSplash_ExStyle, $hMain_GUI)
			_SplashTextSetText($hSplashMsg_GUI, StringFormat($aTXT[$iMSG_S_4], _KeyToStr($sAbortHighlight_HotKey, "+")), -1, "Static2")
			_HotKeyAssign($sAbortHighlight_HotKey, "_HK_AbortHighlight_Proc", -1, $hSplashMsg_GUI)
			
			;         ,      
			;(        ;))
			_CleanAu3Code_Proc($sAu3Content)
			
			$iHighlightProc_TimerInit = TimerInit()
			$sResults = _Au3_SyntaxHighlight_Proc(@CRLF & $sAu3Content & @CRLF, $iHighlight_Mode)
			$iError = @error
			$iHighlightProc_TimerDiff = TimerDiff($iHighlightProc_TimerInit)
			$sResults = StringStripWS($sResults, 3)
			
			If $iError = -1 Or $iAu3SH_AbortHighlight = 1 Then
				_SplashOffEx($hSplashMsg_GUI, $hMain_GUI)
				$iAu3SH_AbortHighlight = 0
				_HotKeyAssign($sAbortHighlight_HotKey, 0)
				ContinueLoop
			ElseIf $iError > 0 Then
				$sSeccesOrFailMsg = $aTXT[$iMSG__50]
			EndIf
			
			;  
			If Not $iNoOutFileSave Then
				FileWrite($sOutputFile, $sResults)
				
				If @error Then
					MsgBox(262144+16, $aTXT[$iMSG__51], StringFormat($aTXT[$iMSG_S_5], $sOutputFileName), 0, $hMain_GUI)
				EndIf
			EndIf
			
			If GUICtrlRead($nEditScriptContent_CB) = 1 Then
				$sMsgFinish = $aTXT[$iMSG__52]
			Else
				$sMsgFinish = StringFormat($aTXT[$iMSG_S_6], _StringGetShortString($sInputFileName, 20))
			EndIf
			
			_SplashTextSetText($hSplashMsg_GUI, StringFormat($aTXT[$iMSG_Nns], $sMsgFinish), $aTXT[$iMSG__53], "Static1")
			_SplashTextSetText($hSplashMsg_GUI, "", -1, "Static2") ;   (  .   )
			_ShowResults_Proc($sSeccesOrFailMsg, $iHighlightProc_TimerDiff, $sResults, $sInputFileName, $hSplashMsg_GUI)
	EndSwitch
Wend

#EndRegion Main Loop

#Region Program Functions

Func _IntegrateToSciTE_Proc()
	Local $iSilentMode_Param = "0"
	
	Local $iAsk = MsgBox(51, $aTXT[$iMSG__54], $aTXT[$iMSG__55], 0, $hMain_GUI)
	
	If $iAsk = 6 Then
		$iSilentMode_Param = "1"
	ElseIf $iAsk = 2 Then
		Return
	EndIf
	
	Local $sAu3_Properties_File = $sSciTEDir & "\au3.properties"
	
	If FileExists($sSciTEDir & "\properties\au3.properties") Then
		$sAu3_Properties_File = $sSciTEDir & "\properties\au3.properties"
	EndIf
	
	Local $sAu3PropsFilePath = StringRegExpReplace($sAu3_Properties_File, "\\[^\\]*$", "")
	Local $sAu3PropsFileName = StringRegExpReplace($sAu3_Properties_File, "^.*\\", "")
	
	Local $sSel_Au3PropsFile = FileOpenDialog($aTXT[$iMSG_SciTE_1], $sAu3PropsFilePath, "Properties (*.properties)", 3, $sAu3PropsFileName, $hMain_GUI)
	
	If Not @error Then
		$sSciTEDir = @WorkingDir
		
		While Not FileExists($sSciTEDir & "\SciTE.exe")
			$sSciTEDir = StringRegExpReplace($sSciTEDir, "\\[^\\]*$", "")
			
			If @extended = 0 Then
				ExitLoop
			EndIf
		WEnd
		
		$sAu3_Properties_File = $sSel_Au3PropsFile
		
		$sAu3PropsFilePath = StringRegExpReplace($sAu3_Properties_File, "\\[^\\]*$", "")
		$sAu3PropsFileName = StringRegExpReplace($sAu3_Properties_File, "^.*\\", "")
	EndIf
	
	Local $sReadAu3PropFile = FileRead($sAu3_Properties_File)
	$sReadAu3PropFile = StringRegExpReplace($sReadAu3PropFile, "(?mi)^\h*?#.*?Au3ToPost.*\n", "")
	
	Local $aItems = StringRegExp($sReadAu3PropFile, "(?i).*command\.(\d+)\..*=.*Au3ToPost.*", 3)
	Local $iLastItem = 0
	
	If IsArray($aItems) Then
		$iLastItem = $aItems[UBound($aItems) - 1]
		
		For $i = 0 To UBound($aItems) - 1
			$sReadAu3PropFile = StringRegExpReplace($sReadAu3PropFile, "(?mi)^\h*?command.*" & $aItems[$i] & "\..*=.*(\n|$)", "")
		Next
	EndIf
	
	Local $aAu3PropFileArr = StringSplit(StringStripCR($sReadAu3PropFile), @LF)
	
	If $iLastItem = 0 Then
		For $i = $aAu3PropFileArr[0] To 1 Step -1
			If StringRegExp($aAu3PropFileArr[$i], '(?i)command\.\d') Then
				$iLastItem = Number(StringRegExpReplace($aAu3PropFileArr[$i], "(?i)command\.(\d+)\..*", "\1")) + 1
				ExitLoop
			EndIf
		Next
	EndIf
	
	If $iLastItem = 0 Then $iLastItem += 1
	Local $iLastWriteItem = $iLastItem
	
	If $sReadAu3PropFile = '' Then
		FileInstall('Resources\au3.properties', $sAu3_Properties_File)
		$sReadAu3PropFile = FileRead($sAu3_Properties_File)
	EndIf
	
	Local $sAdd_Commands = _
		'command.' & $iLastWriteItem & _
		'.$(au3)="$(SciteDefaultHome)\Au3ToPost\Au3ToPost.exe" /FilePath:"$(FilePath)" /Selection:$(CurrentSelection)' & @CRLF & _
		'command.name.' & $iLastWriteItem & '.$(au3)=' & $aTXT[$iMSG_Au3ToPost] & @CRLF & _
		'command.shortcut.' & $iLastWriteItem & '.$(au3)=Ctrl+Shift+H' & @CRLF & _
		'command.is.filter.' & $iLastWriteItem & '.$(au3)=1' & @CRLF & _
		'command.save.before.' & $iLastWriteItem & '.$(au3)=1' & @CRLF
	
	FileCopy($sAu3_Properties_File, $sAu3_Properties_File & ".bak", 1)
	
	If $sAu3PropsFileName = "SciTEToolsMenu.properties" Then
		$sReadAu3PropFile = StringRegExpReplace($sReadAu3PropFile, _
			"(?i)\Qcommand.submenu.name.\E(\d+)\.\*=Util(?:[\n\r\h]+)?", _
			"command.submenu.name.\1.*=Util" & @CRLF & @CRLF & _
			'  #~ Au3ToPost Item' & @CRLF & _
			'  command.separator.' & $iLastWriteItem & '.*=1' & @CRLF & _
			'  command.parent.' & $iLastWriteItem & '.*=\1' & @CRLF & _
			'  command.name.' & $iLastWriteItem & '.*.au3=' & $aTXT[$iMSG_Au3ToPost_1] & @CRLF & _
			'  command.' & $iLastWriteItem & '.*.au3="$(SciteDefaultHome)\\Au3ToPost\\Au3ToPost.exe" /FilePath:"$(FilePath)" /Selection:$(CurrentSelection)' & @CRLF & _
			'  command.shortcut.' & $iLastWriteItem & '.*.au3=Ctrl+Shift+H' & @CRLF & _
			'  command.mode.' & $iLastWriteItem & '.*=subsystem:shellexec,savebefore:yes' & @CRLF & @CRLF & '  ')
		
		Local $hAu3File = FileOpen($sAu3_Properties_File, 2)
		FileWrite($hAu3File, $sReadAu3PropFile)
		FileClose($hAu3File)
	Else
		$hAu3File = FileOpen($sAu3_Properties_File, 2)
		FileWrite($hAu3File, StringStripWS($sReadAu3PropFile, 2) & @CRLF & @CRLF & "#~ Au3ToPost Item" & @CRLF & $sAdd_Commands)
		FileClose($hAu3File)
	EndIf
	
	Local $sAutoItShortPath = FileGetShortName($sAutoItPath & "\Aut2Exe\Aut2Exe.exe")
	Local $sScriptShortPath = FileGetShortName(@ScriptFullPath)
	Local $sScriptDirShortPath = FileGetShortName(@ScriptDir)
	
	DirCreate($sSciTEDir & '\Au3ToPost\Resources')
	
	If Not @Compiled Then
		Run('"' & $sAutoItShortPath & '" /in "' & $sScriptShortPath & '" /out "' & $sSciTEDir & '\Au3ToPost\Au3ToPost.exe" /icon "' & $sScriptDirShortPath & '\Resources\Icon.ico"')
	Else
		FileCopy(@ScriptFullPath, $sSciTEDir & '\Au3ToPost\Au3ToPost.exe', 1)
	EndIf
	
	FileInstall('Resources\au3.styles.properties', $sSciTEDir & '\Au3ToPost\Resources\au3.styles.properties', 1)
	FileInstall('Resources\au3.keywords.properties', $sSciTEDir & '\Au3ToPost\Resources\au3.keywords.properties', 1)
	
	IniWrite($sSciTEDir & '\Au3ToPost\Au3ToPost.ini', 'Prefs', 'Silent Mode', $iSilentMode_Param)
	
	MsgBox(64, $aTXT[$iMSG_Done], _
		$aTXT[$iMSG_ToolsSciTE] & _
		'(' & $aTXT[$iMSG_Au3ToPost_2] & ' --> Ctrl+Shift+H)...' & @LF & _
		$aTXT[$iMSG__56], 0, $hMain_GUI)
EndFunc

Func _Main_Tray_Events()
	Switch @TRAY_ID
		Case $nEndSilentMode_TrayItem, $TRAY_EVENT_PRIMARYUP
			GUISetState(@SW_SHOW, $hMain_GUI)
			TraySetState(2)
			
			If BitAND(WinGetState($hMain_GUI), 16) Then
				GUISetState(@SW_RESTORE, $hMain_GUI)
			EndIf
			
			_HotKeyRelease()
		Case $nStartParse_TrayItem
			_SilentMode_Proc(0)
		Case $nExit_TrayItem
			_ExitScript_Proc()
	EndSwitch
EndFunc

Func _HK_SilentMode_Proc()
	$iSilentMode_HotKey_Called = 1
EndFunc

Func _HK_AbortHighlight_Proc()
	$iAu3SH_AbortHighlight = 1
EndFunc

;      
Func _SilentCheckUpdates_Proc($hWnd)
	If $iAutoUpdateOnStart = 1 Then
		If Number($iAutoUpdateCheckStamp) <= 0 Or TimerDiff($iAutoUpdateCheckStamp) >= ($iAutoUpdateInterval * 60 * 60 * 1000) Then
			IniWrite($sConfig_File, "Prefs", "AutoUpdate Check Stamp", TimerInit())
			_AppCheckUpdates($hWnd, 1, 1, $sApp_Language)
		EndIf
	EndIf
EndFunc

;      
Func _SilentMode_Proc($iExit = 0)
	Opt("TrayIconHide", 0)
	
	Local $sResults, $iTimer
	
	;   (    ),     .
	If $CmdLine[0] = 0 Or $iExit = 0 Then
		$sAu3Content = ClipGet()
		
		If $sAu3Content = "" Then
			Return
		EndIf
		
		TrayTip($aTXT[$iMSG__57], $aTXT[$iMSG__58], 30)
	ElseIf StringInStr($CmdLineRaw, "/Selection:") And $sCustomScriptContent <> "" Then
		$sAu3Content = $sCustomScriptContent
		
		TrayTip($aTXT[$iMSG__59], $aTXT[$iMSG__60], 30)
	ElseIf FileExists($CmdLine[1]) Or StringInStr($CmdLineRaw, "/FilePath:") Then
		;$sAu3Content       . 
		TrayTip($aTXT[$iMSG__61], StringFormat($aTXT[$iMSG_S_7], StringRegExpReplace($sInFile, "^.*\\", "")), 30)
	Else ;  . 
		Return
	EndIf
	
	;         ,      
	;(        ;))
	_CleanAu3Code_Proc($sAu3Content)
	$sResults = _Au3_SyntaxHighlight_Proc($sAu3Content & @CRLF, $iHighlight_Mode)
	$sResults = StringStripWS($sResults, 3)
	
	If $iHighlight_Mode = 3 Then
		$sResults = StringReplace($sWrapTagsTemplate, "%s", $sResults)
	EndIf
	
	ClipPut($sResults)
	
	TrayTip($aTXT[$iMSG__62], $aTXT[$iMSG__63], 10, 1)
	
	If $iExit = 1 Then
		$iTimer = TimerInit()
		
		While BitAND(WinGetState("[CLASS:tooltips_class32]"), 2)
			If TimerDiff($iTimer) >= 10000 Then
				ExitLoop
			EndIf
			
			Sleep(10)
		WEnd
		
		Exit
	EndIf
EndFunc

;             (    SciTE ;) )
Func _CleanAu3Code_Proc(ByRef $sSource)
	Local $sCRLF = @CRLF
	Local $aSourceArr = StringSplit(StringStripCR($sSource), @LF)
	
	$sSource = ""
	
	For $i = 1 To $aSourceArr[0]
		If $i = $aSourceArr[0] Then
			$sCRLF = ""
		EndIf
		
		$sSource &= StringRegExpReplace($aSourceArr[$i], '(\t|\s)+\z', '') & $sCRLF
	Next
EndFunc

;  /     (Edit )      
Func _SwitchEditField_Proc()
	If GUICtrlRead($nEditScriptContent_CB) = 1 Then
		GUICtrlSendMsg($nScriptContent_Edit, $EM_SETREADONLY, False, 0)
		GUICtrlSetData($nScriptContent_Edit, $sCustomScriptContent)

		GUICtrlSetState($nSelectInFile_Button, $GUI_DISABLE)
		GUICtrlSetState($nInFile_Input, $GUI_DISABLE)

		$iCustomScriptContentCheck = 1
	ElseIf GUICtrlRead($nEditScriptContent_CB) <> 1 Then
		GUICtrlSendMsg($nScriptContent_Edit, $EM_SETREADONLY, True, 0)

		GUICtrlSetState($nSelectInFile_Button, $GUI_ENABLE)
		GUICtrlSetState($nInFile_Input, $GUI_ENABLE)

		$sCustomScriptContent = GUICtrlRead($nScriptContent_Edit)
		$iCustomScriptContentCheck = 0
	EndIf

	_CheckInputs_Proc()

	ControlFocus($hMain_GUI, "", $nScriptContent_Edit)
EndFunc

;  /      (    )
Func _SwitchOutFileField_Proc()
	If GUICtrlRead($nNoOutFileSave_CB) = 1 Then
		GUICtrlSetState($nSelectOutFile_Button, $GUI_DISABLE)
		GUICtrlSetState($nOutFile_Input, $GUI_DISABLE)
	Else
		GUICtrlSetState($nSelectOutFile_Button, $GUI_ENABLE)
		GUICtrlSetState($nOutFile_Input, $GUI_ENABLE)
	EndIf
EndFunc

;      
Func _CheckInputs_Proc()
	Local $sInFileInputRead = GUICtrlRead($nInFile_Input)
	Local $sInFileRead = FileRead($sInFileInputRead)
	Local $iEdScrptCont_Checked = Number(GUICtrlRead($nEditScriptContent_CB) = 1)
	
	If Not $iEdScrptCont_Checked And $sAu3Content = "" Then
		GUICtrlSetData($nScriptContent_Edit, "")
	ElseIf Not $iEdScrptCont_Checked And $sAu3Content <> $sInFileRead Then
		GUICtrlSetData($nScriptContent_Edit, $sAu3Content)
	EndIf

	If FileExists($sInFileInputRead) Then
		$sAu3Content = $sInFileRead
	Else
		$sAu3Content = ""
	EndIf
	
	If $iCustomScriptContentCheck = 0 And GUICtrlRead($nScriptContent_Edit) <> $sInFileRead And Not $iEdScrptCont_Checked Then
		GUICtrlSetData($nScriptContent_Edit, $sInFileRead)
	EndIf
EndFunc

; GUI   
Func _ShowResults_Proc($sSeccesOrFailMsg, $iTimerDiff, $sResults, $sScriptName, $hSplashMsg_GUI)
	Local $hResults_GUI, $iChars_Count, $sLabel_Data1, $sLabel_Data2, $sColor, $nResults_Edit, $nEditResults_CB, $nClose_Button, $nCloseAll_Button
	Local $nCopyToClipBoard_Button, $nCopyToClipBoardAndExit_Button, $nPreview_Button
	Local $iClipContentCheck = 0, $sResultsContent, $sClipContent, $iSplash_Timer
	
	GUISetState(@SW_DISABLE, $hMain_GUI)
	$hResults_GUI = GUICreate($aTXT[$iMSG__64], $iResultsGUI_Width, $iResultsGUI_Height, -1, -1, BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPCHILDREN), -1, $hMain_GUI)
	
	If $iSetOnTop = 1 Then
		WinSetOnTop($hResults_GUI, "", 1)
	EndIf
	
	$iChars_Count = StringLen(StringRegExpReplace($sResults, "[\n\r]", ""))
	
	$sLabel_Data1 = _
		StringFormat($aTXT[$iMSG_S_8], '<font color="Green" size="9" weight="800" family="Tahoma">' & $iChars_Count & '</font>')
	
	$sLabel_Data2 = _
		StringFormat($aTXT[$iMSG_S_9], '<font color="Green" size="8.5" weight="800" family="Tahoma">' & _SecondsToTimeStringEx(Round($iTimerDiff / 1000), 2) & '</font>')
	
	$sColor = "green"
	
	If $sSeccesOrFailMsg <> $aTXT[$iMSG__65] Then
		$sColor = "red"
	EndIf
	
	_GUICtrlCreateTFLabel($sLabel_Data1, 20, 5)
	_GUICtrlCreateTFLabel($sLabel_Data2, 20, 20)
	
	Local $sLabel_Data = ''
	
	If GUICtrlRead($nEditScriptContent_CB) <> 1 Then
		$sLabel_Data = _
			'<font color="blue" size="11">' & $aTXT[$iMSG__66] & '</font>' & _
			'<font color="red" size="10" weight="800">' & _StringGetShortString($sScriptName, 20) & '</font> <font color="blue" size="11">' & $aTXT[$iMSG__67] & '</font> ' & _
			'<font color="' & $sColor & '" size="11">' & $sSeccesOrFailMsg & '</font>'
	Else
		$sLabel_Data = '<font color="blue" size="11">' & $aTXT[$iMSG__68] & '</font><font color="' & $sColor & '" size="11">' & $sSeccesOrFailMsg & '</font>'
	EndIf
	
	_GUICtrlCreateTFLabel($sLabel_Data, 20, 45)
	GUISetFont(9, -1, -1, "")
	
	$nResults_Edit = GUICtrlCreateEdit("", 20, 100, $iResultsGUI_Width-40, $iResultsGUI_Height-170, _
		BitOr($GUI_SS_DEFAULT_EDIT, $ES_READONLY), BitOR($WS_EX_DLGMODALFRAME, $WS_EX_CLIENTEDGE))
	
	If $iHighlight_Mode = 3 Then
		$sResults = StringReplace($sWrapTagsTemplate, "%s", $sResults)
	EndIf
	
	GUICtrlSendMsg($nResults_Edit, $EM_LIMITTEXT, -1, 0)
	GUICtrlSetData($nResults_Edit, $sResults)
	
	$nEditResults_CB = GUICtrlCreateCheckbox($aTXT[$iMSG__69], 20, 70)
	
	$nClose_Button = GUICtrlCreateButton("* " & $aTXT[$iMSG__70], 20, $iResultsGUI_Height-55, 140, 20, $BS_DEFPUSHBUTTON)
	$nCloseAll_Button = GUICtrlCreateButton($aTXT[$iMSG__71], 180, $iResultsGUI_Height-55, 140, 20)
	
	$nCopyToClipBoard_Button = GUICtrlCreateButton($aTXT[$iMSG__72], ($iResultsGUI_Width/2)-5, $iResultsGUI_Height-55, 160, 20)
	$nCopyToClipBoardAndExit_Button = GUICtrlCreateButton($aTXT[$iMSG__73], $iResultsGUI_Width-210, $iResultsGUI_Height-55, 190, 20)
	
	$nPreview_Button = GUICtrlCreateButton($aTXT[$iMSG__74], 20, $iResultsGUI_Height-30, 140, 20)
	GUICtrlSetTip(-1, $aTXT[$iMSG_JavaScript])
	
	If $sResults = ClipGet() And $sResults <> "" Then
		$iClipContentCheck = 0
	EndIf
	
	GUISetState(@SW_SHOW, $hResults_GUI)
	GUISetAccelerators($aAccelKeys, $hResults_GUI)
	
	WinActivate($hSplashMsg_GUI)
	$iSplash_Timer = TimerInit()
	
	While 1
		Sleep(20)
		
		;         ( 3 )
		If $iSplash_Timer <> -1 And (TimerDiff($iSplash_Timer) >= 3000 Or WinActive($hResults_GUI)) Then
			$iSplash_Timer = -1
			_SplashOffEx($hSplashMsg_GUI)
			WinActivate($hResults_GUI)
		EndIf
		
		; . ( /  )
		$sResultsContent = GUICtrlRead($nResults_Edit)
		$sClipContent = ClipGet()
		
		If $iClipContentCheck = 0 Then
			If $sResultsContent = $sClipContent Or $sResultsContent = "" Then
				$iClipContentCheck = 1
				
				GUICtrlSetState($nCopyToClipBoard_Button, $GUI_DISABLE)
				GUICtrlSetState($nCopyToClipBoardAndExit_Button, $GUI_DISABLE)
			EndIf
		ElseIf $iClipContentCheck = 1 Then
			If $sResultsContent <> $sClipContent And $sResultsContent <> "" Then
				$iClipContentCheck = 0
				
				GUICtrlSetState($nCopyToClipBoard_Button, $GUI_ENABLE)
				GUICtrlSetState($nCopyToClipBoardAndExit_Button, $GUI_ENABLE)
			EndIf
		EndIf

		Switch GUIGetMsg()
			Case $nClose_Button, $GUI_EVENT_CLOSE
				;  GUI
				GUISetState(@SW_ENABLE, $hMain_GUI)
				GUIDelete($hResults_GUI)
				WinActivate($hMain_GUI)
				;GUISwitch($hMain_GUI)
				
				ExitLoop
			Case $nTab_DummyCtrl
				If _IsFocused($hResults_GUI, $nResults_Edit) Then
					;    Edit  (Chr(9) -> @TAB)
					ControlSend($hResults_GUI, "", $nResults_Edit, "^{TAB}")
				EndIf
			Case $nSelAll_DummyCtrl
				If _IsFocused($hResults_GUI, $nResults_Edit) Then
					;    Edit 
					GUICtrlSendMsg($nResults_Edit, $EM_SETSEL, 0, StringLen(GUICtrlRead($nResults_Edit)))
				EndIf
			Case $nPreview_Button
				Local $sPreview_Module = @TempDir & "\Preview_Au3ToPost_Module.html"
				Local $sRead_Results = GUICtrlRead($nResults_Edit)
				
				If $iHighlight_Mode = -1 Then
					Local $hFOpen = FileOpen($sPreview_Module, 2 + 8)
					FileWrite($hFOpen, $sRead_Results)
					FileClose($hFOpen)
				Else
					FileInstall(".\Resources\Preview_Module.html", $sPreview_Module, 1)
					
					$sRead_Results = StringReplace($sRead_Results, " ", "&nbsp;")
					
					Local $sRead_PM = StringRegExpReplace(FileRead($sPreview_Module), _
						'(?s)(<textarea id=".*?" rows=\d+ cols=\d+ style="white-space: pre">).*?(</textarea>.*?)$', '<pre>\1' & @CRLF & StringReplace($sRead_Results, '\', '\\') & @CRLF & '\2</pre>')
					
					Local $hFOpen = FileOpen($sPreview_Module, 2 + 8)
					FileWrite($hFOpen, $sRead_PM)
					FileClose($hFOpen)
				EndIf
				
				ShellExecute($sPreview_Module)
				
				If $iSetOnTop = 1 Then
					WinSetState($hMain_GUI, "", @SW_MINIMIZE)
					WinSetState($hResults_GUI, "", @SW_MINIMIZE)
				EndIf
				
				;Sleep(1000)
				;FileDelete($sPreview_Module)
			Case $nEditResults_CB
				If GUICtrlRead($nEditResults_CB) = 1 Then
					$sResults = GUICtrlRead($nResults_Edit)
					
					GUICtrlSendMsg($nResults_Edit, $EM_SETREADONLY, False, 0)
					GUICtrlSetData($nResults_Edit, $sResults)
				Else
					$sResults = GUICtrlRead($nResults_Edit)
					
					GUICtrlSendMsg($nResults_Edit, $EM_SETREADONLY, True, 0)
					GUICtrlSetData($nResults_Edit, $sResults)
				EndIf
				GUICtrlSetState($nResults_Edit, $GUI_FOCUS)
			Case $nCopyToClipBoard_Button
				;    
				ClipPut(GUICtrlRead($nResults_Edit))
			Case $nCopyToClipBoardAndExit_Button
				;      
				ClipPut(GUICtrlRead($nResults_Edit))
				
				GUISetState(@SW_HIDE, $hMain_GUI)
				GUISetState(@SW_HIDE, $hResults_GUI)
				
				_ExitScript_Proc()
			Case $nCloseAll_Button
				; 
				
				GUISetState(@SW_HIDE, $hMain_GUI)
				GUISetState(@SW_HIDE, $hResults_GUI)
				
				_ExitScript_Proc()
		EndSwitch
	WEnd
EndFunc

;     GUI  
Func _IsFocused($hWnd, $nCID)
    Return ControlGetHandle($hWnd, '', $nCID) = ControlGetHandle($hWnd, '', ControlGetFocus($hWnd))
EndFunc

;  /    SciTE
Func _GetSciTEDir($sAutoItPath)
	Local $sSciTEDir = $sAutoItPath & "\SciTE" ;IniRead($sConfig_File, "Prefs", "SciTe Path", "")
	
	If Not FileExists($sSciTEDir & "\SciTE.exe") Then $sSciTEDir = $sAutoItPath & "\SciTE"
	If Not FileExists($sSciTEDir & "\SciTE.exe") Then $sSciTEDir = @ScriptDir
	
	If Not FileExists($sSciTEDir & "\SciTE.exe") Then
		Local $sInitDir = $sSciTEDir
		Local $sMsgText = $aTXT[$iMSG_SciTE_2]
		
		MsgBox(262144+48, $sApp_ShortTitle & " - " & $aTXT[$iMSG__75], $aTXT[$iMSG_SciTE_3] & @LF & $sMsgText, 10)
		
		While 1
			$sSciTEDir = FileSelectFolder($sMsgText, 0, 6, $sInitDir)
			If @error Then ExitLoop

			If Not FileExists($sSciTEDir & "\SciTE.exe") Then
				MsgBox(262144+48, $sApp_ShortTitle & " - " & $aTXT[$iMSG__76], $aTXT[$iMSG_SciTESciTEexe] & @LF & $sMsgText, 10)
				$sInitDir = $sSciTEDir
				ContinueLoop
			EndIf
			
			IniWrite($sConfig_File, "Prefs", "SciTe Path", $sSciTEDir)
			ExitLoop
		WEnd
	EndIf
	
	If Not FileExists($sSciTEDir & "\SciTE.exe") Then
		;MsgBox(262144+16, $sApp_ShortTitle & " - " & $aTXT[$iMSG__77], StringFormat($aTXT[$iMSG_SciTEnNnOKEXIT]))
		;Exit
	EndIf
	
	Return $sSciTEDir
EndFunc

;      
Func _GetCmdLine($sCmdLine, $sArgument)
	If Not StringInStr($sCmdLine, $sArgument) Then Return ""

	Local $sRetCmd = StringRegExpReplace($sCmdLine, '(?si).*?' & $sArgument & '"(.*?)".*?$', '\1')
	If $sRetCmd = $sCmdLine Or @extended < 1 Then Return ""
	
	Return StringStripWS($sRetCmd, 3)
EndFunc

Func _SplashTextOnEx($sTitle, $sText, $iW=800, $iH=600, $iX=-1, $iY=-1, $sFntName=-1, $iFntSz=-1, $iFntWd=-1, $iFntAtrb=0, $nFntClr=-1, $nStyle=-1, $nExStyle=-1, $hParent=0)
	If IsHWnd($hParent) Then
		GUISetState(@SW_DISABLE, $hParent)
	EndIf
	
	Local $hSplash = GUICreate($sTitle, $iW, $iH, $iX, $iY, $nStyle, $nExStyle, $hParent)
	GUISetBkColor(0xFFFFFF, $hSplash)
	
	Local $nLabel = GUICtrlCreateLabel($sText, 0, ($iH/2)-15, $iW, $iH, $SS_CENTER)
	
	GUICtrlSetFont($nLabel, $iFntSz, $iFntWd, $iFntAtrb, $sFntName)
	GUICtrlSetColor($nLabel, $nFntClr)
	
	Local $nStatusLabel = GUICtrlCreateLabel("", 0, 5, $iW, 15, $SS_CENTER)
	
	GUICtrlSetFont($nStatusLabel, 8, 800, 4, "Tahoma")
	GUICtrlSetColor($nStatusLabel, 0x757575)
	
	GUISetState(@SW_SHOW, $hSplash)
	Return $hSplash
EndFunc

Func _SplashTextSetText($hSplash, $sText, $sTitle = -1, $sCtrlClass = "Static1")
	ControlSetText($hSplash, "", $sCtrlClass, $sText)
	
	If $sTitle <> -1 Then
		WinSetTitle($hSplash, "", $sTitle)
	EndIf
EndFunc

Func _SplashOffEx($hSplash, $hParent = 0)
	If IsHWnd($hParent) Then
		GUISetState(@SW_ENABLE, $hParent)
	EndIf
	
	Return GUIDelete($hSplash)
EndFunc

Func _StringGetShortString($sString, $iMax_Ret_Lenght=30)
	If StringLen($sString) < $iMax_Ret_Lenght Then Return $sString
	
	If $iMax_Ret_Lenght <= 4 Then $iMax_Ret_Lenght = 5
	Local $iSide_Lenght = Round(($iMax_Ret_Lenght / 2) - 2, 0)
	
	Local $sLeft_Side = StringStripWS(StringLeft($sString, $iSide_Lenght), 3)
	Local $sRight_Side = StringStripWS(StringRight($sString, $iSide_Lenght), 3)
	
	Return $sLeft_Side & "...." & $sRight_Side
EndFunc

Func _SecondsToTimeStringEx($iSeconds, $iFlag = 0, $sDelim = ", ")
	Local $sYear, $sYears, $s5Years, $sDay, $sDays, $s5Days, $sHour, $sHours, $s5Hours, $sMin, $sMins, $s5Mins, $sSec, $sSecs, $s5Secs
	
;~ 	If StringInStr('0419', @OSLang) Then
		Local $sYear = $aTXT[$iMSG__78], $sYears = $aTXT[$iMSG__79], $s5Years = $aTXT[$iMSG__80]
		Local $sDay = $aTXT[$iMSG__81], $sDays = $aTXT[$iMSG__82], $s5Days = $aTXT[$iMSG__83]
		Local $sHour = $aTXT[$iMSG__84], $sHours = $aTXT[$iMSG__85], $s5Hours = $aTXT[$iMSG__86]
		Local $sMin = $aTXT[$iMSG__87], $sMins = $aTXT[$iMSG__88], $s5Mins = $aTXT[$iMSG__89]
		Local $sSec = $aTXT[$iMSG__90], $sSecs = $aTXT[$iMSG__91], $s5Secs = $aTXT[$iMSG__92]
;~ 	Else
;~ 		Local $sYear = 'Year', $sYears = 'Years', $s5Years = 'Years'
;~ 		Local $sDay = 'Day', $sDays = 'Days', $s5Days = 'Days'
;~ 		Local $sHour = 'Hour', $sHours = 'Hours', $s5Hours = 'Hours'
;~ 		Local $sMin = 'Minute', $sMins = 'Minutes', $s5Mins = 'Minutes'
;~ 		Local $sSec = 'Second', $sSecs = 'Seconds', $s5Secs = 'Seconds'
;~ 	EndIf
	
	If Number($iSeconds) >= 0 Then
		Local $iTicks = Int($iSeconds / 3600), $iDays, $iYears
		Local $iHours = Mod($iTicks, 24)
		
		If $iTicks >= 24 Then
			$iDays = ($iTicks - $iHours) / 24
		EndIf
		
		If $iDays >= 365 Or BitAND($iFlag, 2) = 0 Then
			$iYears = Int($iDays / 365)
			
			If ($iYears >= 20 And StringRight($iYears, 1) >= 2) Or ($iYears < 20 And $iYears >= 2) Then
				$sYear = $sYears
			EndIf
			
			If ($iYears >= 20 And (StringRight($iYears, 1) >= 5 Or StringRight($iYears, 1) < 1)) Or ($iYears < 20 And $iYears >= 5) Or $iYears = 0 Then
				$sYear = $s5Years
			EndIf
			
			$iYears &= " " & $sYear & $sDelim
		EndIf
		
		If $iDays > 0 Or BitAND($iFlag, 2) = 0 Then
			$iDays = Mod($iDays, 365)
			
			If ($iDays >= 20 And StringRight($iDays, 1) >= 2) Or ($iDays < 20 And $iDays >= 2) Then
				$sDay = $sDays
			EndIf
			
			If ($iDays >= 20 And (StringRight($iDays, 1) >= 5) Or StringRight($iDays, 1) < 1) Or ($iDays < 20 And $iDays >= 5) Or $iDays = 0 Then
				$sDay = $s5Days
			EndIf
			
			$iDays &= " " & $sDay & $sDelim
		EndIf
		
		$iTicks = Mod($iSeconds, 3600)
		
		Local $iMins = Int($iTicks / 60)
		Local $iSecs = Round(Mod($iTicks, 60))
		
		If BitAND($iFlag, 1) = 1 Then
			If StringLen($iHours) = 1 Then
				$iHours = "0" & $iHours
			EndIf
			
			If StringLen($iMins) = 1 Then
				$iMins = "0" & $iMins
			EndIf
			
			If StringLen($iSecs) = 1 Then
				$iSecs = "0" & $iSecs
			EndIf
		EndIf
		
		If ($iHours >= 20 And StringRight($iHours, 1) >= 2) Or ($iHours < 20 And $iHours >= 2) Then
			$sHour = $sHours
		EndIf
		If ($iHours >= 20 And (StringRight($iHours, 1) >= 5 Or StringRight($iHours, 1) < 1)) Or ($iHours < 20 And $iHours >= 5) Or $iHours = 0 Then
			$sHour = $s5Hours
		EndIf
		If ($iMins >= 20 And StringRight($iMins, 1) >= 2) Or ($iMins < 20 And $iMins >= 2) Then
			$sMin = $sMins
		EndIf
		If ($iMins >= 20 And (StringRight($iMins, 1) >= 5 Or StringRight($iMins, 1) < 1)) Or ($iMins < 20 And $iMins >= 5) Or $iMins = 0 Then
			$sMin = $s5Mins
		EndIf
		If ($iSecs >= 20 And StringRight($iSecs, 1) >= 2) Or ($iSecs < 20 And $iSecs >= 2) Then
			$sSec = $sSecs
		EndIf
		If ($iSecs >= 20 And (StringRight($iSecs, 1) >= 5 Or StringRight($iSecs, 1) < 1)) Or ($iSecs < 20 And $iSecs >= 5) Or $iSecs = 0 Then
			$sSec = $s5Secs
		EndIf
		
		If BitAND($iFlag, 2) = 2 Then
			If Number($iHours) = 0 Then
				$iHours = ""
			Else
				$iHours &= " " & $sHour & $sDelim
			EndIf
			
			If Number($iMins) = 0 Then
				$iMins = ""
			Else
				$iMins &= " " & $sMin & $sDelim
			EndIf
		Else
			$iHours &= " " & $sHour & $sDelim
			$iMins &= " " & $sMin & $sDelim
		EndIf
		
		$iSecs &= " " & $sSec
		
		Return $iYears & $iDays & $iHours & $iMins & $iSecs
	EndIf
	
	Return SetError(1, 0, 0)
EndFunc

Func _FixAccelHotKeyLayout()
	Local Const $WM_INPUTLANGCHANGEREQUEST = 0x50
	Local $aRet = DllCall("user32.dll", "long", "LoadKeyboardLayoutW", "wstr", 0x04090000, "int", 0)
	
	If Not @error And $aRet[0] Then
		DllCall("user32.dll", "ptr", "SendMessage", "hwnd", WinGetHandle(AutoItWinGetTitle()), "int", $WM_INPUTLANGCHANGEREQUEST, "int", 1, "int", $aRet[0])
		Return 1
	EndIf
	
	Return SetError(1, 0, 0)
EndFunc

;  -   GUI
Func WM_GETMINMAXINFO($hWnd, $nMsg, $wParam, $lParam)
	Local $iMINGuiX = $iMainGUI_Width
	Local $iMINGuiY = $iMainGUI_Height
	Local $iMAXGuiX = @DesktopWidth
	Local $iMAXGuiY = @DesktopHeight
	
	If $hWnd <> $hMain_GUI Then
		$iMINGuiX = $iResultsGUI_Width
		$iMINGuiY = $iResultsGUI_Height + 14
	EndIf
	
	Local $iMinMaxInfo = DllStructCreate("int;int;int;int;int;int;int;int;int;int", $lParam)
	
	DllStructSetData($iMinMaxInfo, 7, $iMINGuiX + 12) ; min X
	DllStructSetData($iMinMaxInfo, 8, $iMINGuiY + 12) ; min Y
 	;DllStructSetData($iMinMaxInfo, 9, $iMAXGuiX) ; max X
 	;DllStructSetData($iMinMaxInfo, 10, $iMAXGuiY) ; max Y
	
	Return $GUI_RUNDEFMSG
EndFunc

Func WM_COMMAND($hWnd, $nMsg, $wParam, $lParam)
	Local $nNotifyCode = BitShift($wParam, 16)
	Local $nID = BitAND($wParam, 0xFFFF)
	Local $hCtrl = $lParam
	
	Switch $nNotifyCode
		Case $EN_CHANGE, $EN_UPDATE
			Switch $nID
				Case $nInFile_Input;, $nScriptContent_Edit
					_CheckInputs_Proc()
			EndSwitch
		Case $EN_SETFOCUS
			
		Case $EN_KILLFOCUS
			
	EndSwitch
	
	Return $GUI_RUNDEFMSG
EndFunc

;      (    )
Func _ExitScript_Proc()
	IniWrite($sConfig_File, "Prefs", "Not write out file", Number(GUICtrlRead($nNoOutFileSave_CB) = $GUI_CHECKED))
	IniWrite($sConfig_File, "Prefs", "Type Custom Code",  Number(GUICtrlRead($nEditScriptContent_CB) = $GUI_CHECKED))
	
	IniWrite($sConfig_File, "Prefs", "Last used inFile", GUICtrlRead($nInFile_Input))
	IniWrite($sConfig_File, "Prefs", "Last used outFile", GUICtrlRead($nOutFile_Input))
	
	Exit
EndFunc

#EndRegion Program Functions
