#include <GUIConstants.au3>
#include <EditConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Misc.au3>
#include <WinAPI.au3>

#Region Global Variables

Global $__AboutBox_aCoverGUIs[42]
Global $__AboutBox_iOldLeftPos, $__AboutBox_iOldTopPos, $__AboutBox_iScrollPos, $__AboutBox_iFirstScroll, $__AboutBox_iScrollLines
Global $__AboutBox_iScrollTimer, $__AboutBox_iScrollSpeed = 1, $__AboutBox_iCustomScrollSpeed = 3
Global $__AboutBox_iLastMouseYPos = -1, $__AboutBox_iIsScrolling = 0, $__AboutBox_hIsPressed

#EndRegion Global Variables

#Region Public Variables

Global $ABOUTBOX_ScrollMovieEffect = 1

#EndRegion Public Variables

#Region Public Functions

Func _AboutBox($sTitle, $sMainLabelText, $sBodyText, $sScrollText, $sCopyRText, $aHyperLinks, $hParent = 0, $sIconFile = "", $nLinkColor = 0x0000FF, $nBkColor = 0xFFFFFF, $iWidth = 300, $iHeight = 120, $iLeft = -1, $iTop = -1, $nStyle = -1, $nExStyle = -1)
	Local $iOld_Opt = Opt("GUIOnEventMode", 0)
	Local $hAbout_GUI, $hScroll_GUI, $nScroll_Label, $iAbout_Msg, $aCurInfo
	Local $iHyperLinks_Count = UBound($aHyperLinks)
	Local $anLinkLabel[$iHyperLinks_Count][2] = [[$iHyperLinks_Count - 1]], $iLinkTop = 120, $iDelim_Pos, $sURL, $sURL_Title
	
	WinSetState($hParent, "", @SW_DISABLE)
	
	If $nExStyle = -1 Then $nExStyle = 0
	$nExStyle = BitOR($WS_EX_TOOLWINDOW, $nExStyle)
	
	$hAbout_GUI = GUICreate($sTitle, $iWidth, $iHeight, $iLeft, $iTop, $nStyle, $nExStyle, $hParent)
	GUISetBkColor($nBkColor)
	
	GUICtrlCreateLabel($sMainLabelText, 5, 20, $iWidth, 40, $ES_CENTER, $GUI_WS_EX_PARENTDRAG)
	GUICtrlSetFont(-1, 14)
	
	GUICtrlCreateIcon($sIconFile, 0, 10, 20)
	GUICtrlSetState(-1, 128)
	
	GUICtrlCreateGraphic(5, 75, $iWidth - 10, 3, $SS_ETCHEDFRAME)
	
	For $i = 1 To $iHyperLinks_Count - 1
		$iDelim_Pos = StringInStr($aHyperLinks[$i], "|")
		$sURL = StringTrimLeft($aHyperLinks[$i], $iDelim_Pos)
		$sURL_Title = StringLeft($aHyperLinks[$i], $iDelim_Pos - 1)
		
		If $sURL = "" Then
			ContinueLoop
		EndIf
		
		$anLinkLabel[$i][0] = __AboutBox_GUICtrlHyperlink_Create($sURL_Title, $iWidth - 150, $iLinkTop, -1, 15, $nLinkColor, $sURL, $SS_CENTER)
		$anLinkLabel[$i][1] = $sURL
		
		$iLinkTop += 30
	Next
	
	GUICtrlCreateLabel($sBodyText, 10, 100, 115, $iHeight/2)
	GUICtrlSetFont(-1, 10, 600, 0, "Tahoma")
	
	GUICtrlCreateLabel($sCopyRText, 0, $iHeight - 20, $iWidth, -1, 1)
	GUICtrlSetColor(-1, 0x969696)
	GUICtrlSetState(-1, 128)
	
	If Not $ABOUTBOX_ScrollMovieEffect Then
		$hScroll_GUI = GUICreate('', 180, 160, 150, 90, $WS_CHILD, -1, $hAbout_GUI)
	Else
		$hScroll_GUI = GUICreate('', 180, 160, 150, 90, $WS_CHILD, BitOR($WS_EX_CLIENTEDGE, $WS_EX_DLGMODALFRAME, $WS_EX_COMPOSITED), $hAbout_GUI)
		GUISetBkColor(0x0)
	EndIf
	
	$sScrollText = StringReplace($sScrollText, "\n", @CRLF)
	$__AboutBox_iScrollLines = (@extended * 20)
	
	$nScroll_Label = GUICtrlCreateLabel($sScrollText, 0, 50, 180, 520, $ES_CENTER)
	GUICtrlSetState(-1, $GUI_HIDE)
	GUICtrlSetCursor(-1, 0)
	GUICtrlSetFont(-1, 9, 0, 0, "Tahoma")
	
	If Not $ABOUTBOX_ScrollMovieEffect Then
		GUICtrlSetColor(-1, 0x804000)
	Else
		GUICtrlSetColor(-1, 0xFFFFFF)
	EndIf
	
	Dim $__AboutBox_iScrollPos = -50, $__AboutBox_iFirstScroll = 1, $__AboutBox_iScrollTimer = TimerInit()
	Local $iTransHeight = 2, $iTransValue = (UBound($__AboutBox_aCoverGUIs)/2) - 1, $aParentPos = WinGetPos($hAbout_GUI)
	
	If $ABOUTBOX_ScrollMovieEffect Then $iTransHeight = 1
	
	$__AboutBox_iOldLeftPos = $aParentPos[0]
	$__AboutBox_iOldTopPos = $aParentPos[1]
	
	For $i = 0 To $iTransValue
		;Top Cover
		$__AboutBox_aCoverGUIs[$i] = GUICreate("", 220, $iTransHeight + 2, 130 + $aParentPos[0], $iTransHeight * $i + 110 + $aParentPos[1], $WS_POPUP, -1, $hAbout_GUI)
		
		GUISetBkColor($nBkColor, $__AboutBox_aCoverGUIs[$i])
		WinSetTrans($__AboutBox_aCoverGUIs[$i], "", (255 / $iTransValue) * (-1 * ($i - $iTransValue)))
		
		;Bottom cover
		$__AboutBox_aCoverGUIs[$i + $iTransValue + 1] = GUICreate("", 220, $iTransHeight + 2, 130 + $aParentPos[0], 260 - $iTransHeight * $i + $aParentPos[1] + 20, _
			$WS_POPUP, -1, $hAbout_GUI)
		
		GUISetBkColor($nBkColor, $__AboutBox_aCoverGUIs[$i + $iTransValue + 1])
		WinSetTrans($__AboutBox_aCoverGUIs[$i + $iTransValue + 1], "", (255 / $iTransValue) * (-1 * ($i - $iTransValue)))
	Next
	
	GUISetState(@SW_SHOW, $hAbout_GUI)
	GUISetState(@SW_SHOW, $hScroll_GUI)
	
	For $i = 0 To 41
		GUISetState(@SW_SHOW, $__AboutBox_aCoverGUIs[$i])
	Next
	
	GUICtrlSetState($nScroll_Label, $GUI_SHOW)
	
	$__AboutBox_hIsPressed = DllOpen("User32.dll")
	
	Local $hCallBack = DllCallbackRegister("__AboutBox_ScrollText_CallBack_Proc", "none", "hwnd;int;int;dword")
	Local $ahTimer = DllCall("user32.dll", "int", "SetTimer", "hwnd", $hScroll_GUI, "int", 1001, "int", 10, "ptr", DllCallbackGetPtr($hCallBack))
	
	GUISwitch($hAbout_GUI)
	GUIRegisterMsg($WM_MOVE, "__AboutBox_WM_MOVE")
	WinActivate($hAbout_GUI)
	
	SoundPlay(@SystemDir & "\oobe\images\title.wma", 0)
	
	While 1
		$iAbout_Msg = GUIGetMsg()
		
		Switch $iAbout_Msg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $anLinkLabel[1][0] To $anLinkLabel[$anLinkLabel[0][0]][0]
				For $i = 1 To $anLinkLabel[0][0]
					If $iAbout_Msg = $anLinkLabel[$i][0] Then
						__AboutBox_GUICtrlHyperlink_Handler($hAbout_GUI, $anLinkLabel[$i][0], $anLinkLabel[$i][1], -1, 0x551A8B)
						ExitLoop
					EndIf
				Next
		EndSwitch
	WEnd
	
	DllCall("user32.dll", "int", "KillTimer", "hwnd", $hScroll_GUI, "int", $ahTimer[0])
	DllCallbackFree($hCallBack)
	DllClose($__AboutBox_hIsPressed)
	
	GUIRegisterMsg($WM_MOVE, "")
	SoundPlay("")
	
	For $i = 0 To 41
		GUIDelete($__AboutBox_aCoverGUIs[$i])
	Next
	
	WinSetState($hParent, "", @SW_ENABLE)
	GUIDelete($hAbout_GUI)
	
	GUISwitch($hParent)
	Opt("GUIOnEventMode", $iOld_Opt)
EndFunc

#EndRegion Public Functions

#Region Internal Functions

Func __AboutBox_ScrollText_CallBack_Proc($hWnd, $iMsg, $wParam, $lParam)
	Local $hScroll_Label_Wnd = ControlGetHandle($hWnd, "", "Static1")
	Local $iScroll_Label_Ctrl = DllCall("user32.dll", "int", "GetDlgCtrlID", "hwnd", $hScroll_Label_Wnd)
	$iScroll_Label_Ctrl = $iScroll_Label_Ctrl[0]
	
	If ($__AboutBox_iIsScrolling Or __AboutBox_Control_GetHovered() = $hScroll_Label_Wnd) And _IsPressed(01, $__AboutBox_hIsPressed) Then
		Local $iCurrent_Mouse_YPos = MouseGetPos(1)
		$__AboutBox_iIsScrolling = 1
		
		If $__AboutBox_iLastMouseYPos < $iCurrent_Mouse_YPos Then ;Move up
			$__AboutBox_iScrollPos -= $__AboutBox_iCustomScrollSpeed
			
			ControlMove($hWnd, "", "Static1", 0, -$__AboutBox_iScrollPos)
		ElseIf $__AboutBox_iLastMouseYPos > $iCurrent_Mouse_YPos Then ;Move down
			$__AboutBox_iScrollPos += $__AboutBox_iCustomScrollSpeed
			
			ControlMove($hWnd, "", "Static1", 0, -$__AboutBox_iScrollPos)
		EndIf
		
		GUICtrlSetCursor($iScroll_Label_Ctrl, 11)
		
		$__AboutBox_iLastMouseYPos = $iCurrent_Mouse_YPos
		$__AboutBox_iScrollTimer = TimerInit()
		$__AboutBox_iFirstScroll = 1
		
		If $__AboutBox_iScrollPos > $__AboutBox_iScrollLines Or $__AboutBox_iScrollPos < -$__AboutBox_iScrollLines Then $__AboutBox_iScrollPos = -150
		
		Return
	ElseIf $__AboutBox_iIsScrolling Then
		$__AboutBox_iIsScrolling = 0
		GUICtrlSetCursor($iScroll_Label_Ctrl, 0)
	EndIf
	
	If ($__AboutBox_iFirstScroll And TimerDiff($__AboutBox_iScrollTimer) > 1000) Or (Not $__AboutBox_iFirstScroll And TimerDiff($__AboutBox_iScrollTimer) > 30) Then
		$__AboutBox_iFirstScroll = 0
		$__AboutBox_iScrollTimer = TimerInit()
		$__AboutBox_iScrollPos += $__AboutBox_iScrollSpeed
		
		ControlMove($hWnd, "", "Static1", 0, -$__AboutBox_iScrollPos)
		If $__AboutBox_iScrollPos > $__AboutBox_iScrollLines Then $__AboutBox_iScrollPos = -150
	EndIf
EndFunc

Func __AboutBox_WM_MOVE($hWndGUI, $MsgID, $wParam, $lParam)
	Local $aParentPosArr, $aChildPosArr, $iNew_Left, $iNew_Top
	$aParentPosArr = WinGetPos($hWndGUI)
	
	For $i = 0 To 41
		$aChildPosArr = WinGetPos($__AboutBox_aCoverGUIs[$i])
		
		$iNew_Left = $aChildPosArr[0]
		$iNew_Top = $aChildPosArr[1]
		
		If $__AboutBox_iOldLeftPos > $aParentPosArr[0] Then
			$iNew_Left = $aChildPosArr[0] + ($aParentPosArr[0] - $__AboutBox_iOldLeftPos)
		ElseIf $__AboutBox_iOldLeftPos < $aParentPosArr[0] Then
			$iNew_Left = $aChildPosArr[0] - ($__AboutBox_iOldLeftPos - $aParentPosArr[0])
		EndIf
		
		If $__AboutBox_iOldTopPos > $aParentPosArr[1] Then
			$iNew_Top = $aChildPosArr[1] - ($__AboutBox_iOldTopPos - $aParentPosArr[1])
		ElseIf $__AboutBox_iOldTopPos < $aParentPosArr[1] Then
			$iNew_Top = $aChildPosArr[1] + ($aParentPosArr[1] - $__AboutBox_iOldTopPos)
		EndIf
		
		If $__AboutBox_iOldLeftPos = $iNew_Left And $__AboutBox_iOldTopPos = $iNew_Top Then Return
		
		WinMove($__AboutBox_aCoverGUIs[$i], "", $iNew_Left, $iNew_Top)
	Next
	
	$__AboutBox_iOldLeftPos = $aParentPosArr[0]
	$__AboutBox_iOldTopPos = $aParentPosArr[1]
EndFunc

Func __AboutBox_Control_GetHovered()
	Local $iOld_Opt_MCM = Opt("MouseCoordMode", 1)
	Local $Ret = DllCall("user32.dll", "int", "WindowFromPoint", "long", MouseGetPos(0), "long", MouseGetPos(1))
	
	Opt("MouseCoordMode", $iOld_Opt_MCM)
	
	Return HWnd($Ret[0])
EndFunc

Func __AboutBox_GUICtrlHyperlink_Create($sText, $iLeft, $iTop, $iWidth = -1, $iHeight = -1, $iColor = 0x0000FF, $sToolTip = '', $iStyle = -1, $iExStyle = -1)
	If $iWidth = -1 Then
		$iWidth = __AboutBox_GUICtrlLabelGetTextWidth($sText)
		$iWidth = $iWidth[0]
		
		If Not $iWidth Then
			$iWidth = -1
		EndIf
	EndIf
	
	If $iStyle <> -1 And BitAND($iStyle, $SS_CENTER) Then
		$iLeft += -($iWidth / 2) + 70
	EndIf
	
	Local $ID = GUICtrlCreateLabel($sText, $iLeft, $iTop, $iWidth, $iHeight, $iStyle, $iExStyle)
	
	If $ID Then
		GUICtrlSetFont($ID, -1, -1, 4)
		GUICtrlSetColor($ID, $iColor)
		GUICtrlSetCursor($ID, 0)
		GUICtrlSetTip($ID, $sToolTip)
	EndIf
	
	Return $ID
EndFunc

Func __AboutBox_GUICtrlHyperlink_Handler($hWnd, $iCtrlID, $sActionURL, $iAction = -1, $iVisitedColor = 0x551A8B)
	Local $aCurInfo = GUIGetCursorInfo($hWnd)
	
	If Not IsArray($aCurInfo) Then
		Return SetError(1, 0, 0)
	EndIf
	
	While IsArray($aCurInfo) And $aCurInfo[2] = 1
		$aCurInfo = GUIGetCursorInfo($hWnd)
		
		If $aCurInfo[4] <> $iCtrlID Then
			GUISetCursor(7, 1, $hWnd)
		Else
			GUISetCursor(2, 0, $hWnd)
		EndIf
		
		Sleep(10)
	WEnd
	
	GUISetCursor(2, 0, $hWnd)
	
	If IsArray($aCurInfo) And $aCurInfo[4] = $iCtrlID Then
		If $iAction = 1 Then
			Execute($sActionURL)
		ElseIf $iAction = -1 Then
			ShellExecute($sActionURL)
		EndIf
		
		If @error = 0 And $iVisitedColor Then
			GUICtrlSetColor($iCtrlID, $iVisitedColor)
		EndIf
		
		Return 1
	EndIf
	
	Return SetError(1, 0, 0)
EndFunc

Func __AboutBox_GUICtrlLabelGetTextWidth($s_Data, $i_FontSize = 8.5, $i_FontWeight = -1, $s_TextFont = "Arial")
	Local Const $DEFAULT_CHARSET = 0 ; ANSI character set
	Local Const $OUT_CHARACTER_PRECIS = 2
	Local Const $CLIP_DEFAULT_PRECIS = 0
	Local Const $PROOF_QUALITY = 2
	Local Const $FIXED_PITCH = 1
	Local Const $RGN_XOR = 3
	Local Const $LOGPIXELSY = 90
	
	If $i_FontWeight = "" Or $i_FontWeight = -1 Then
		$i_FontWeight = 400 ; default Font weight
	EndIf
	
	Local $hDC = _WinAPI_GetDC(0)
	Local $intDeviceCap = _WinAPI_GetDeviceCaps($hDC, $LOGPIXELSY)
	Local $intFontHeight = _WinAPI_MulDiv($i_FontSize, $intDeviceCap, 72)
	Local $hFont = _WinAPI_CreateFont(-$intFontHeight, 0, 0, 0, $i_FontWeight, 0, 0, 0, _
		$DEFAULT_CHARSET, $OUT_CHARACTER_PRECIS, $CLIP_DEFAULT_PRECIS, $PROOF_QUALITY, $FIXED_PITCH, $s_TextFont)
	
	_WinAPI_SelectObject($hDC, $hFont)
	Local $stRet = _WinAPI_GetTextExtentPoint32($hDC, $s_Data)
	
	_WinAPI_DeleteObject($hFont)
    _WinAPI_ReleaseDC(0, $hDC)
    ;_WinAPI_InvalidateRect(0, 0)
	
	Local $a_RetLen[2] = [DllStructGetData($stRet, 1), DllStructGetData($stRet, 2)]
	Return $a_RetLen
EndFunc
#EndRegion Internal Functions
