#include-once
#include <GUIConstantsEx.au3>
#include <ComboConstants.au3>
#include <WindowsConstants.au3>

Global Enum _
	$iMSG_First = 0, _
		$iMSG_Au3, $iMSG__0, $iMSG__1, $iMSG__2, $iMSG__3, _
		$iMSG_I, $iMSG_SnnNnsnn, $iMSG_I_1, $iMSG__4, $iMSG__5, _
		$iMSG_S, $iMSG_S_1, $iMSG__6, $iMSG__7, $iMSG__8, _
		$iMSG_SciTE, $iMSG__9, $iMSG__10, $iMSG__11, $iMSG__12, _
		$iMSG__13, $iMSG__14, $iMSG__15, $iMSG__16, $iMSG__17, _
		$iMSG__18, $iMSG__19, $iMSG__20, $iMSG__21, $iMSG__22, _
		$iMSG__23, $iMSG__24, $iMSG__25, $iMSG__26, $iMSG__27, _
		$iMSG__28, $iMSG_Html, $iMSG_BBCode, $iMSG__29, $iMSG__30, _
		$iMSG__31, $iMSG__32, $iMSG__33, $iMSG__34, $iMSG__35, _
		$iMSG__36, $iMSG__37, $iMSG__38, $iMSG__39, $iMSG_TestedOn, _
		$iMSG_Credits, $iMSG_AutoItTeamnAuto_ynAndManyOthers, $iMSG_Version, $iMSG__40, $iMSG__41, _
		$iMSG_TxtFiles, $iMSG_AllFiles, $iMSG_RetsartProgram, _
		$iMSG__42, $iMSG_S_2, $iMSG__43, $iMSG__44, $iMSG__45, _
		$iMSG__46, $iMSG__47, $iMSG_S_3, $iMSG__48, $iMSG__49, _
		$iMSG_Nn, $iMSG_S_4, $iMSG__50, $iMSG__51, $iMSG_S_5, _
		$iMSG__52, $iMSG_S_6, $iMSG_Nns, $iMSG__53, $iMSG__54, _
		$iMSG__55, $iMSG_SciTE_1, $iMSG_Au3ToPost, $iMSG_Au3ToPost_1, $iMSG_Done, _
		$iMSG_ToolsSciTE, $iMSG_Au3ToPost_2, $iMSG__56, $iMSG__57, $iMSG__58, _
		$iMSG__59, $iMSG__60, $iMSG__61, $iMSG_S_7, $iMSG__62, _
		$iMSG__63, $iMSG__64, $iMSG_S_8, $iMSG_S_9, $iMSG__65, _
		$iMSG__66, $iMSG__67, $iMSG__68, $iMSG__69, $iMSG__70, _
		$iMSG__71, $iMSG__72, $iMSG__73, $iMSG__74, $iMSG_JavaScript, _
		$iMSG_SciTE_2, $iMSG__75, $iMSG_SciTE_3, $iMSG__76, $iMSG_SciTESciTEexe, _
		$iMSG__77, $iMSG_SciTEnNnOKEXIT, $iMSG__78, $iMSG__79, $iMSG__80, _
		$iMSG__81, $iMSG__82, $iMSG__83, $iMSG__84, $iMSG__85, _
		$iMSG__86, $iMSG__87, $iMSG__88, $iMSG__89, $iMSG__90, _
		$iMSG__91, $iMSG__92, _
	$iMSG_Last

Global Const $LANGS_DIR = @ScriptDir & '\Languages'
Global $aTXT_IDs[$iMSG_Last] = [$iMSG_Last-1]
Global $aTXT = _AppTranslation_Register($LANGS_DIR & "\English.lng")

If StringInStr($CmdLineRaw, '/GenerateLangFile') Then
	$sLngName = StringRegExpReplace($CmdLineRaw, '(?i).*?/GenerateLangFile:(?:"([^"]*)".*|.*?)', '\1')
	$sLangFile = $LANGS_DIR & '\' & $sLngName & '.lng'
	If @extended = 0 Or $sLngName = '' Then $sLangFile = '' ;Generate strings for languages found in $LANGS_DIR
	_AppTranslation_GenerateLangFile($sLangFile)
	Exit
EndIf

Func _AppTranslation_Register($sLangFile, $sSetDataFunc = "")
	Local $aTXT[$iMSG_Last] = [$iMSG_Last-1]
	Local $iFileEncoding = FileGetEncoding($sLangFile)
	
	;Default values
	$aTXT[$iMSG_Au3] = _AppTranslation_GetString($sLangFile, "Au3", "  Au3-    ", $iFileEncoding)
	$aTXT[$iMSG__0] = _AppTranslation_GetString($sLangFile, "_0", "", $iFileEncoding)
	$aTXT[$iMSG__1] = _AppTranslation_GetString($sLangFile, "_1", "", $iFileEncoding)
	$aTXT[$iMSG__2] = _AppTranslation_GetString($sLangFile, "_2", " ", $iFileEncoding)
	$aTXT[$iMSG__3] = _AppTranslation_GetString($sLangFile, "_3", ",   .", $iFileEncoding)
	$aTXT[$iMSG_I] = _AppTranslation_GetString($sLangFile, "I", "  (%i)   . ,    .", $iFileEncoding)
	$aTXT[$iMSG_SnnNnsnn] = _AppTranslation_GetString($sLangFile, "SnnNnsnn", "    (%s).\n\n :\n\n%s\n\n    ?", $iFileEncoding)
	$aTXT[$iMSG_I_1] = _AppTranslation_GetString($sLangFile, "I_1", "  (%i)    . ,    .", $iFileEncoding)
	$aTXT[$iMSG__4] = _AppTranslation_GetString($sLangFile, "_4", "     .", $iFileEncoding)
	$aTXT[$iMSG__5] = _AppTranslation_GetString($sLangFile, "_5", ",        .", $iFileEncoding)
	$aTXT[$iMSG_S] = _AppTranslation_GetString($sLangFile, "S", " [%s]", $iFileEncoding)
	$aTXT[$iMSG_S_1] = _AppTranslation_GetString($sLangFile, "S_1", ": %s%%", $iFileEncoding)
	$aTXT[$iMSG__6] = _AppTranslation_GetString($sLangFile, "_6", "", $iFileEncoding)
	$aTXT[$iMSG__7] = _AppTranslation_GetString($sLangFile, "_7", "", $iFileEncoding)
	$aTXT[$iMSG__8] = _AppTranslation_GetString($sLangFile, "_8", "  ' '", $iFileEncoding)
	$aTXT[$iMSG_SciTE] = _AppTranslation_GetString($sLangFile, "SciTE", "   SciTE", $iFileEncoding)
	$aTXT[$iMSG__9] = _AppTranslation_GetString($sLangFile, "_9", "", $iFileEncoding)
	$aTXT[$iMSG__10] = _AppTranslation_GetString($sLangFile, "_10", "", $iFileEncoding)
	$aTXT[$iMSG__11] = _AppTranslation_GetString($sLangFile, "_11", " ...", $iFileEncoding)
	$aTXT[$iMSG__12] = _AppTranslation_GetString($sLangFile, "_12", " ", $iFileEncoding)
	$aTXT[$iMSG__13] = _AppTranslation_GetString($sLangFile, "_13", "...", $iFileEncoding)
	$aTXT[$iMSG__14] = _AppTranslation_GetString($sLangFile, "_14", "  ' '...", $iFileEncoding)
	$aTXT[$iMSG__15] = _AppTranslation_GetString($sLangFile, "_15", "  ", $iFileEncoding)
	$aTXT[$iMSG__16] = _AppTranslation_GetString($sLangFile, "_16", "      :", $iFileEncoding)
	$aTXT[$iMSG__17] = _AppTranslation_GetString($sLangFile, "_17", "    ", $iFileEncoding)
	$aTXT[$iMSG__18] = _AppTranslation_GetString($sLangFile, "_18", "   :", $iFileEncoding)
	$aTXT[$iMSG__19] = _AppTranslation_GetString($sLangFile, "_19", "  ", $iFileEncoding)
	$aTXT[$iMSG__20] = _AppTranslation_GetString($sLangFile, "_20", "", $iFileEncoding)
	$aTXT[$iMSG__21] = _AppTranslation_GetString($sLangFile, "_21", "", $iFileEncoding)
	$aTXT[$iMSG__22] = _AppTranslation_GetString($sLangFile, "_22", "", $iFileEncoding)
	$aTXT[$iMSG__23] = _AppTranslation_GetString($sLangFile, "_23", "", $iFileEncoding)
	$aTXT[$iMSG__24] = _AppTranslation_GetString($sLangFile, "_24", "     ", $iFileEncoding)
	$aTXT[$iMSG__25] = _AppTranslation_GetString($sLangFile, "_25", "  ' '  ", $iFileEncoding)
	$aTXT[$iMSG__26] = _AppTranslation_GetString($sLangFile, "_26", "  ", $iFileEncoding)
	$aTXT[$iMSG__27] = _AppTranslation_GetString($sLangFile, "_27", "    ", $iFileEncoding)
	$aTXT[$iMSG__28] = _AppTranslation_GetString($sLangFile, "_28", " ", $iFileEncoding)
	$aTXT[$iMSG_Html] = _AppTranslation_GetString($sLangFile, "Html", "Html ", $iFileEncoding)
	$aTXT[$iMSG_BBCode] = _AppTranslation_GetString($sLangFile, "BBCode", "BBCode ", $iFileEncoding)
	$aTXT[$iMSG__29] = _AppTranslation_GetString($sLangFile, "_29", "  :", $iFileEncoding)
	$aTXT[$iMSG__30] = _AppTranslation_GetString($sLangFile, "_30", " ", $iFileEncoding)
	$aTXT[$iMSG__31] = _AppTranslation_GetString($sLangFile, "_31", "    :", $iFileEncoding)
	$aTXT[$iMSG__32] = _AppTranslation_GetString($sLangFile, "_32", "  :", $iFileEncoding)
	$aTXT[$iMSG__33] = _AppTranslation_GetString($sLangFile, "_33", " ", $iFileEncoding)
	$aTXT[$iMSG__34] = _AppTranslation_GetString($sLangFile, "_34", "    ", $iFileEncoding)
	$aTXT[$iMSG__35] = _AppTranslation_GetString($sLangFile, "_35", "  :", $iFileEncoding)
	$aTXT[$iMSG__36] = _AppTranslation_GetString($sLangFile, "_36", ".", $iFileEncoding)
	$aTXT[$iMSG__37] = _AppTranslation_GetString($sLangFile, "_37", "", $iFileEncoding)
	$aTXT[$iMSG__38] = _AppTranslation_GetString($sLangFile, "_38", "", $iFileEncoding)
	$aTXT[$iMSG__39] = _AppTranslation_GetString($sLangFile, "_39", "...", $iFileEncoding)
	$aTXT[$iMSG_TestedOn] = _AppTranslation_GetString($sLangFile, "TestedOn", "Tested on:", $iFileEncoding)
	$aTXT[$iMSG_Credits] = _AppTranslation_GetString($sLangFile, "Credits", "Credits:", $iFileEncoding)
	$aTXT[$iMSG_AutoItTeamnAuto_ynAndManyOthers] = _AppTranslation_GetString($sLangFile, "AutoItTeamnAuto_ynAndManyOthers", "AutoIt Team\nAutoIt Community\n... and many others", $iFileEncoding)
	$aTXT[$iMSG_Version] = _AppTranslation_GetString($sLangFile, "Version", "Version: ", $iFileEncoding)
	$aTXT[$iMSG__40] = _AppTranslation_GetString($sLangFile, "_40", "    ...", $iFileEncoding)
	$aTXT[$iMSG__41] = _AppTranslation_GetString($sLangFile, "_41", "      ", $iFileEncoding)
	$aTXT[$iMSG_TxtFiles] = _AppTranslation_GetString($sLangFile, "TxtFiles", " ", $iFileEncoding)
	$aTXT[$iMSG_AllFiles] = _AppTranslation_GetString($sLangFile, "AllFiles", " ", $iFileEncoding)
	$aTXT[$iMSG_RetsartProgram] = _AppTranslation_GetString($sLangFile, "RetsartProgram", "  .", $iFileEncoding)
	$aTXT[$iMSG__42] = _AppTranslation_GetString($sLangFile, "_42", '', $iFileEncoding)
	$aTXT[$iMSG_S_2] = _AppTranslation_GetString($sLangFile, "S_2", '   <%s>', $iFileEncoding)
	$aTXT[$iMSG__43] = _AppTranslation_GetString($sLangFile, "_43", '', $iFileEncoding)
	$aTXT[$iMSG__44] = _AppTranslation_GetString($sLangFile, "_44", '    ,     .', $iFileEncoding)
	$aTXT[$iMSG__45] = _AppTranslation_GetString($sLangFile, "_45", '', $iFileEncoding)
	$aTXT[$iMSG__46] = _AppTranslation_GetString($sLangFile, "_46", '  ,   ?', $iFileEncoding)
	$aTXT[$iMSG__47] = _AppTranslation_GetString($sLangFile, "_47", "  ...", $iFileEncoding)
	$aTXT[$iMSG_S_3] = _AppTranslation_GetString($sLangFile, "S_3", "  <%s>  ...", $iFileEncoding)
	$aTXT[$iMSG__48] = _AppTranslation_GetString($sLangFile, "_48", "!", $iFileEncoding)
	$aTXT[$iMSG__49] = _AppTranslation_GetString($sLangFile, "_49", " ", $iFileEncoding)
	$aTXT[$iMSG_Nn] = _AppTranslation_GetString($sLangFile, "Nn", " \n\n , ", $iFileEncoding)
	$aTXT[$iMSG_S_4] = _AppTranslation_GetString($sLangFile, "S_4", "    <%s>", $iFileEncoding)
	$aTXT[$iMSG__50] = _AppTranslation_GetString($sLangFile, "_50", " ", $iFileEncoding)
	$aTXT[$iMSG__51] = _AppTranslation_GetString($sLangFile, "_51", "", $iFileEncoding)
	$aTXT[$iMSG_S_5] = _AppTranslation_GetString($sLangFile, "S_5", "   <%s>", $iFileEncoding)
	$aTXT[$iMSG__52] = _AppTranslation_GetString($sLangFile, "_52", "  ", $iFileEncoding)
	$aTXT[$iMSG_S_6] = _AppTranslation_GetString($sLangFile, "S_6", "  <%s> ", $iFileEncoding)
	$aTXT[$iMSG_Nns] = _AppTranslation_GetString($sLangFile, "Nns", " !\n\n%s", $iFileEncoding)
	$aTXT[$iMSG__53] = _AppTranslation_GetString($sLangFile, "_53", " !", $iFileEncoding)
	$aTXT[$iMSG__54] = _AppTranslation_GetString($sLangFile, "_54", " ", $iFileEncoding)
	$aTXT[$iMSG__55] = _AppTranslation_GetString($sLangFile, "_55", "      ?", $iFileEncoding)
	$aTXT[$iMSG_SciTE_1] = _AppTranslation_GetString($sLangFile, "SciTE_1", "    SciTE", $iFileEncoding)
	$aTXT[$iMSG_Au3ToPost] = _AppTranslation_GetString($sLangFile, "Au3ToPost", '      (Au3ToPost)', $iFileEncoding)
	$aTXT[$iMSG_Au3ToPost_1] = _AppTranslation_GetString($sLangFile, "Au3ToPost_1", '      (Au3ToPost)', $iFileEncoding)
	$aTXT[$iMSG_Done] = _AppTranslation_GetString($sLangFile, "Done", 'Done!', $iFileEncoding)
	$aTXT[$iMSG_ToolsSciTE] = _AppTranslation_GetString($sLangFile, "ToolsSciTE", '     <Tools/>  SciTE ', $iFileEncoding)
	$aTXT[$iMSG_Au3ToPost_2] = _AppTranslation_GetString($sLangFile, "Au3ToPost_2", ' "      (Au3ToPost)"', $iFileEncoding)
	$aTXT[$iMSG__56] = _AppTranslation_GetString($sLangFile, "_56", '   .', $iFileEncoding)
	$aTXT[$iMSG__57] = _AppTranslation_GetString($sLangFile, "_57", " ", $iFileEncoding)
	$aTXT[$iMSG__58] = _AppTranslation_GetString($sLangFile, "_58", " ,     ...", $iFileEncoding)
	$aTXT[$iMSG__59] = _AppTranslation_GetString($sLangFile, "_59", " ", $iFileEncoding)
	$aTXT[$iMSG__60] = _AppTranslation_GetString($sLangFile, "_60", " ,     ...", $iFileEncoding)
	$aTXT[$iMSG__61] = _AppTranslation_GetString($sLangFile, "_61", " ", $iFileEncoding)
	$aTXT[$iMSG_S_7] = _AppTranslation_GetString($sLangFile, "S_7", " ,   <%s>  ...", $iFileEncoding)
	$aTXT[$iMSG__62] = _AppTranslation_GetString($sLangFile, "_62", " !", $iFileEncoding)
	$aTXT[$iMSG__63] = _AppTranslation_GetString($sLangFile, "_63", "     .", $iFileEncoding)
	$aTXT[$iMSG__64] = _AppTranslation_GetString($sLangFile, "_64", " ", $iFileEncoding)
	$aTXT[$iMSG_S_8] = _AppTranslation_GetString($sLangFile, "S_8", '  %s ', $iFileEncoding)
	$aTXT[$iMSG_S_9] = _AppTranslation_GetString($sLangFile, "S_9", '  : %s', $iFileEncoding)
	$aTXT[$iMSG__65] = _AppTranslation_GetString($sLangFile, "_65", "!", $iFileEncoding)
	$aTXT[$iMSG__66] = _AppTranslation_GetString($sLangFile, "_66", ' ', $iFileEncoding)
	$aTXT[$iMSG__67] = _AppTranslation_GetString($sLangFile, "_67", '', $iFileEncoding)
	$aTXT[$iMSG__68] = _AppTranslation_GetString($sLangFile, "_68", '    ', $iFileEncoding)
	$aTXT[$iMSG__69] = _AppTranslation_GetString($sLangFile, "_69", " ", $iFileEncoding)
	$aTXT[$iMSG__70] = _AppTranslation_GetString($sLangFile, "_70", "  ", $iFileEncoding)
	$aTXT[$iMSG__71] = _AppTranslation_GetString($sLangFile, "_71", " ", $iFileEncoding)
	$aTXT[$iMSG__72] = _AppTranslation_GetString($sLangFile, "_72", "  .", $iFileEncoding)
	$aTXT[$iMSG__73] = _AppTranslation_GetString($sLangFile, "_73", ".   ", $iFileEncoding)
	$aTXT[$iMSG__74] = _AppTranslation_GetString($sLangFile, "_74", "", $iFileEncoding)
	$aTXT[$iMSG_JavaScript] = _AppTranslation_GetString($sLangFile, "JavaScript", "       - JavaScript   !", $iFileEncoding)
	$aTXT[$iMSG_SciTE_2] = _AppTranslation_GetString($sLangFile, "SciTE_2", "       SciTE...", $iFileEncoding)
	$aTXT[$iMSG__75] = _AppTranslation_GetString($sLangFile, "_75", "", $iFileEncoding)
	$aTXT[$iMSG_SciTE_3] = _AppTranslation_GetString($sLangFile, "SciTE_3", "   SciTE.", $iFileEncoding)
	$aTXT[$iMSG__76] = _AppTranslation_GetString($sLangFile, "_76", "", $iFileEncoding)
	$aTXT[$iMSG_SciTESciTEexe] = _AppTranslation_GetString($sLangFile, "SciTESciTEexe", "   SciTE (SciTE.exe).", $iFileEncoding)
	$aTXT[$iMSG__77] = _AppTranslation_GetString($sLangFile, "_77", "...", $iFileEncoding)
	$aTXT[$iMSG_SciTEnNnOKEXIT] = _AppTranslation_GetString($sLangFile, "SciTEnNnOKEXIT", "   SciTE.\n,         :(.\n\nOK   --->   EXIT", $iFileEncoding)
	$aTXT[$iMSG__78] = _AppTranslation_GetString($sLangFile, "_78", '', $iFileEncoding)
	$aTXT[$iMSG__79] = _AppTranslation_GetString($sLangFile, "_79", '', $iFileEncoding)
	$aTXT[$iMSG__80] = _AppTranslation_GetString($sLangFile, "_80", '', $iFileEncoding)
	$aTXT[$iMSG__81] = _AppTranslation_GetString($sLangFile, "_81", '', $iFileEncoding)
	$aTXT[$iMSG__82] = _AppTranslation_GetString($sLangFile, "_82", '', $iFileEncoding)
	$aTXT[$iMSG__83] = _AppTranslation_GetString($sLangFile, "_83", '', $iFileEncoding)
	$aTXT[$iMSG__84] = _AppTranslation_GetString($sLangFile, "_84", '', $iFileEncoding)
	$aTXT[$iMSG__85] = _AppTranslation_GetString($sLangFile, "_85", '', $iFileEncoding)
	$aTXT[$iMSG__86] = _AppTranslation_GetString($sLangFile, "_86", '', $iFileEncoding)
	$aTXT[$iMSG__87] = _AppTranslation_GetString($sLangFile, "_87", '', $iFileEncoding)
	$aTXT[$iMSG__88] = _AppTranslation_GetString($sLangFile, "_88", '', $iFileEncoding)
	$aTXT[$iMSG__89] = _AppTranslation_GetString($sLangFile, "_89", '', $iFileEncoding)
	$aTXT[$iMSG__90] = _AppTranslation_GetString($sLangFile, "_90", '', $iFileEncoding)
	$aTXT[$iMSG__91] = _AppTranslation_GetString($sLangFile, "_91", '', $iFileEncoding)
	$aTXT[$iMSG__92] = _AppTranslation_GetString($sLangFile, "_92", '', $iFileEncoding)
	
	If $sSetDataFunc <> "" Then
		Call($sSetDataFunc, $aTXT)
	EndIf
	
	Return $aTXT
EndFunc

Func _AppTranslation_GetLanguages($sLangs_Dir, $bRetArray = False)
	Local $sRet, $sLngFileName, $hSearch = FileFindFirstFile($sLangs_Dir & "\*.lng")
	If $hSearch = -1 Then Return SetError(-1, 0, '')
	
	While 1
		$sLngFileName = FileFindNextFile($hSearch)
		If @error <> 0 Then ExitLoop
		$sRet &= StringLeft($sLngFileName, StringInStr($sLngFileName, ".", 2, -1) - 1) & "|"
	WEnd
	
	FileClose($hSearch)
	
	If $sRet = "" Then Return SetError(1, 0, "")
	
	$sRet = StringTrimRight($sRet, 1)
	If $bRetArray Then $sRet = StringSplit($sRet, "|")
	Return $sRet
EndFunc

Func _AppTranslation_GetString($sLangFile, $sIdentifier, $sDefault = "", $iFileEncoding = 0)
	$aTXT_IDs[Eval('iMSG_' & $sIdentifier)] = $sIdentifier
	
	Local $sStr = IniRead($sLangFile, "Translation", $sIdentifier, $sDefault)
	
	If $iFileEncoding >= 128 Then
		$sStr = BinaryToString(StringToBinary($sStr), 4)
	EndIf
	
	Return $sStr
EndFunc

Func _AppTranslation_GenerateLangFile($sLangFile = '', $sAppName = @ScriptName, $sAppVer = -1, $sLngAuthor = '')
	Local $aLangs[2] = [1, $sLangFile]
	
	If $sLangFile = '' Then
		$aLangs = _AppTranslation_GetLanguages($LANGS_DIR, True)
	ElseIf Not FileExists($sLangFile) Then
		If $sAppName = @ScriptName Then $sAppName = StringRegExpReplace($sAppName, '\.[^\.]*$', '')
		
		If $sAppVer = -1 Then
			If @Compiled Then
				$sAppVer = StringLeft(FileGetVersion(@ScriptFullPath, 'FileVersion'), 3)
			Else
				$sAppVer = '1.0'
			EndIf
		EndIf
		
		IniWrite($sLangFile, 'Info', 'Program', $sAppName)
		IniWrite($sLangFile, 'Info', 'Version', $sAppVer)
		IniWrite($sLangFile, 'Info', 'Language', StringRegExpReplace($sLangFile, '^.*\\|\.[^\.]*$', ''))
		IniWrite($sLangFile, 'Info', 'Author', '')
	EndIf
	
	For $iLng = 1 To $aLangs[0]
		If $aLangs[$iLng] = '' Then ContinueLoop
		
		If $sLangFile = '' Then
			$aLangs[$iLng] = $LANGS_DIR & '\' & $aLangs[$iLng] & '.lng'
		EndIf
		
		For $i = 1 To $aTXT[0]
			If IniRead($aLangs[$iLng], 'Translation', $aTXT_IDs[$i], '@DEFAULT@') == '@DEFAULT@' Then
				IniWrite($aLangs[$iLng], 'Translation', $aTXT_IDs[$i], $aTXT[$i])
			EndIf
		Next
	Next
EndFunc

Func _AppTranslation_SelectLangGUI($sAppName, $hParent = 0, $sDefLng = "")
	Local $hGUI, $nLng_Combo, $nOK_Bttn, $iMsg
	
	GUISetState(@SW_DISABLE, $hParent)
	$hGUI = GUICreate($sAppName, 300, 120, -1, -1, -1, $WS_EX_TOOLWINDOW, $hParent)
	
	GUICtrlCreateLabel("Language:", 20, 22, 80, 17)
	$nLng_Combo = GUICtrlCreateCombo("", 110, 20, 170, 50, BitOr($GUI_SS_DEFAULT_COMBO, $CBS_DROPDOWNLIST))
	GUICtrlSetData($nLng_Combo, _AppTranslation_GetLanguages($LANGS_DIR), $sDefLng)
	$nOK_Bttn = GUICtrlCreateButton("OK", 20, 90, 70, 20)
	
	GUISetState(@SW_SHOW, $hGUI)
	
	While 1
		$iMsg = GUIGetMsg()
		
		Switch $iMsg
			Case $GUI_EVENT_CLOSE, $nOK_Bttn
				ExitLoop
		EndSwitch
	WEnd
	
	$sDefLng = GUICtrlRead($nLng_Combo)
	$aTXT = _AppTranslation_Register($LANGS_DIR & "\" & $sDefLng & ".lng")
	
	GUISetState(@SW_ENABLE, $hParent)
	GUIDelete($hGUI)
	
	Return $sDefLng
EndFunc
